// Anything required here wil by default be combined/minified by r.js
// if you use it.
define(['ucApp', 'routeDefs', 'common/amoebaDataFactory', 'common/amoebaService'], function(ucApp) {
    ucApp.config(['routeDefsProvider', function(routeDefsProvider) {
        console.log("ucApp.config");

        // in large applications, you don't want to clutter up app.config
        // with routing particulars.  You probably have enough going on here.
        // Use a service provider to manage your routing.

     }]);

    ucApp.run([
        '$couchPotato', '$state', '$stateParams','$document', '$rootScope', '$http', "amoebaDataFactory", "amoebaService",
        function($couchPotato, $state, $stateParams, $document, $rootScope, $http, amoebaDataFactory, amoebaService) {
            //var BOOL_USE_INTERFACE = false;
            console.log("ucApp.run");

            // by assigning the couchPotato service to the lazy property, we
            // the register functions will know to run-time-register components
            // instead of config-time-registering them.
            ucApp.lazy = $couchPotato;

            // angular-ui-project recommends assigning these services to the root
            // scope.  Others have argued that doing so can lead to obscured
            // dependencies and that making services directly available to html and
            // directives is unclean.  In any case, the ui-router demo assumes these
            // are available in the DOM, therefore they should be on $rootScope.
            $rootScope.$state = $state;
            $rootScope.$stateParams = $stateParams;
            if(!BOOL_USE_INTERFACE)
            {
                $http.get('assets/jsons/test/conversation.json')
                    .then(function(result){
                        amoebaDataFactory.conversationData = result.data.conversation;
                        //console.log("conversation");
                        //console.log(amoebaDataFactory.conversationData);
                     },function(result){
                   // Fail
                 });
                $http.get('assets/jsons/test/contact.json')
                    .then(function(result){
                        amoebaDataFactory.contactData = result.data.contact;
                        //console.log('contact');
                        //console.log(amoebaDataFactory.contactData);
                     },function(result){
                   // Fail
                 });
                $http.get('assets/jsons/test/chatContent.json')
                    .then(function(result){
                        amoebaDataFactory.chatData = result.data;
                        //console.log(amoebaDataFactory.chatData);
                    },function(result){
                        // Fail
                    });
                $http.get('assets/jsons/test/picture.json')
                    .then(function(result){
                        amoebaDataFactory.pictureData = result.data.picture;
                        //console.log('picture');
                        //console.log(amoebaDataFactory.pictureData);
                    },function(result){
                        // Fail
                    });
                $http.get('assets/jsons/test/allUsers.json')
                    .then(function(result){
                        amoebaDataFactory.allUserData = result.data.allUsers;
                        //console.log('allUsers');
                        //console.log(amoebaDataFactory.allUserData);
                    },function(result){

                        // Fail
                    });
                $http.get('assets/jsons/test/contactUsers.json')
                    .then(function(result){
                        amoebaDataFactory.contactUserData = result.data.contactUsers;
                        //console.log('contactUsers');
                        //console.log(amoebaDataFactory.contactUserData);
                    },function(result){

                        // Fail
                    });
                //trans
                $http.get('assets/jsons/test/transUsers.json')
                    .then(function(result){
                        amoebaDataFactory.transUserData = result.data.transUsers;
                        //console.log('trans');
                        //console.log(amoebaDataFactory.transUserData);
                    },function(result){

                        // Fail
                    });
                $http.get('assets/jsons/test/userInformation.json')
                    .then(function(result){
                        amoebaDataFactory.userInfoData = result.data.userInfo;
                        amoebaDataFactory.noticeData = [
                            {
                                "mail" : "Gmail",
                                "content" : "Integrate your favorite tools with ERICSSON-LG",
                                "time" : "10:15 PM, Today"
                            },
                            {
                                "mail" : "Gmail",
                                "content" : "Product release plan",
                                "time" : "10:12 PM, Today"
                            },
                            {
                                "mail" : "Gmail",
                                "content" : "Scotty added you back on Google+",
                                "time" : "10:07 PM, Today"
                            }
                        ]
                        //console.log('picture');
                        //console.log(amoebaDataFactory.userInfoData);
                    },function(result){
                        // Fail
                    });

                // login 설정 가져오기
                $http.get('assets/jsons/test/loginSetting.json')
                    .then(function(result){
                        amoebaDataFactory.loginData = result.data;
                        //console.log('loginSetting');
                        //console.log(amoebaDataFactory.loginData);

                        getLangList();

                    },function(result){

                    });
                function getLangList(){
                    $http.get('assets/jsons/test/langInfo.json')
                        .then(function(result){
                            amoebaDataFactory.langInfo = result.data;
                            //console.log('langInfo');
                            //console.log(amoebaDataFactory.langInfo);

                            getLangData();

                        },function(result){

                        });
                }
                function getLangData(){
                    var lang = amoebaDataFactory.loginData.str_language.val;
                    var datas = amoebaDataFactory.langInfo.data;
                    var fileName = "en";

                    for(var i in datas){
                        if(lang == datas[i].name){
                            fileName = datas[i].fileName;
                        }

                    }

                    $http.get('assets/jsons/languages/'+fileName+'.json')
                        .then(function(result){
                            amoebaDataFactory.global = result.data;
                            //console.log('global');
                            //console.log(amoebaDataFactory.global);
                        },function(result){

                        });
                }
                $http.get('assets/jsons/test/multiLoginProfiles.json')
                    .then(function(result){
                        amoebaDataFactory.multiLoginProfiles = result.data;
                        //console.log('multiLoginProfiles');
                        //console.log(amoebaDataFactory.multiLoginProfiles);
                    },function(result){

                    });
                $http.get('assets/jsons/test/memoDatas.json')
                    .then(function(result){
                        amoebaDataFactory.memoData = result.data.memo;
                        //console.log('memoData');
                        //console.log(amoebaDataFactory.memoData);
                    },function(result){

                    });
                $http.get('assets/jsons/test/organization.json')
                    .then(function (result) {
                        amoebaDataFactory.organization = result.data.data;
                        //console.log('organization');
                        //console.log(amoebaDataFactory.organization);
                    }, function (result) {
                    });

                $http.get('assets/jsons/test/myProfile.json')
                    .then(function(result){
                        amoebaDataFactory.myProfile = result.data;
                        //console.log('myProfile');
                        //console.log(amoebaDataFactory.myProfile);
                    },function(result){
                    });
                $http.get('assets/jsons/test/schedule.json')
                    .then(function(result){
                        amoebaDataFactory.schedule = result.data.schedule;
                        //console.log('schedule');
                        //console.log(amoebaDataFactory.schedule);
                    },function(result){
                    });
                $http.get('assets/jsons/test/sms.json')
                    .then(function(result){
                        amoebaDataFactory.smsData = result.data.sms;
                        //console.log('smsData');
                        //console.log(amoebaDataFactory.smsData);
                    },function(result){

                    });
                $http.get('assets/jsons/test/voice.json')
                    .then(function(result){
                        amoebaDataFactory.voiceData = result.data.voice;
                        //console.log('smsData');
                        //console.log(amoebaDataFactory.voiceData);
                    },function(result){
                    });
                $http.get('assets/jsons/test/forwardLogs.json')
                    .then(function(result){
                        amoebaDataFactory.forwardLogs = result.data.forwardLogs;
                        //console.log('forwardLogs');
                        //console.log(amoebaDataFactory.forwardLogs);
                    },function(result){
                    });
            }

            // **********************************************************************************
            // **********************************************************************************
            // **********************************************************************************
            // **********************************************************************************
            // **********************************************************************************

            // GLOBAL PARAMETER
            HUNDRED_YEAR = Date.create(Date.now()).format('{yyyy}').slice(0, 2);

	        // static data
	        amoebaDataFactory.langInfo = AMOEBA.DATA_STATIC.langInfo;
	        amoebaDataFactory.userInfoData = AMOEBA.DATA_STATIC.userInfoData;
	        amoebaDataFactory.userSetting = AMOEBA.DATA_STATIC.userSetting;
	        amoebaDataFactory.loginInfo = AMOEBA.DATA_STATIC.loginInfo;
	        amoebaDataFactory.myStatus = AMOEBA.DATA_STATIC.myStatus;
            amoebaDataFactory.editableUserInfo = AMOEBA.DATA_STATIC.editableUserInfo;
            amoebaDataFactory.currentVoice = AMOEBA.DATA_STATIC.currentVoice;
            amoebaDataFactory.ringTemp.ring = AMOEBA.DATA_STATIC.ring;

	        // template data
	        amoebaDataFactory.contactDataforPremium = AMOEBA.DATA_TEMPLATE.contactDataforPremium;
	        amoebaDataFactory.contactDataforStandard = AMOEBA.DATA_TEMPLATE.contactDataforStandard;
	        amoebaDataFactory.basicCTemp = AMOEBA.DATA_TEMPLATE.basicCTemp;
	        amoebaDataFactory.chatBasicTemp = AMOEBA.DATA_TEMPLATE.chatBasicTemp;
	        amoebaDataFactory.basicGTemp = AMOEBA.DATA_TEMPLATE.basicGTemp;
	        amoebaDataFactory.basicUserTemp = AMOEBA.DATA_TEMPLATE.basicUserTemp;
	        amoebaDataFactory.smsBasicTemp = AMOEBA.DATA_TEMPLATE.smsBasicTemp;
	        amoebaDataFactory.smsDataBasicTemp = AMOEBA.DATA_TEMPLATE.smsDataBasicTemp;
	        amoebaDataFactory.transloginfo = AMOEBA.DATA_TEMPLATE.transloginfo;
	        amoebaDataFactory.meomTemp = AMOEBA.DATA_TEMPLATE.memoTemp;
	        amoebaDataFactory.forwardTemp = AMOEBA.DATA_TEMPLATE.forwardTemp;
            amoebaDataFactory.callUserInfoTemp = AMOEBA.DATA_TEMPLATE.callUserInfoTemp;
            amoebaDataFactory.contactuserTemp = AMOEBA.DATA_TEMPLATE.contactuserTemp;
            amoebaDataFactory.oneuserTemp = AMOEBA.DATA_TEMPLATE.oneuserTemp;
            amoebaDataFactory.searchuserTemp = AMOEBA.DATA_TEMPLATE.searchuserTemp;

            // loginTmpl.html Input Setting
            $http.get('assets/jsons/input/loginInput.json')
            .then(function(result){
            	amoebaDataFactory.loginInput = result.data.data;
            	//console.log('loginInput');
            	//console.log(amoebaDataFactory.loginInput);
            },function(result){
            });

            // mainTmpl.html Input Setting
            $http.get('assets/jsons/input/mainInput.json')
            .then(function(result){
            	amoebaDataFactory.mainInput = result.data.data;
            	//console.log('mainInput');
            	//console.log(amoebaDataFactory.mainInput);
            },function(result){
            });

            // addContactTmpl.html Input Setting
            $http.get('assets/jsons/input/contactInput.json')
            .then(function(result){
            	amoebaDataFactory.contactInput = result.data.data;
            	//console.log('contactInput');
            	//console.log(amoebaDataFactory.contactInput);
            },function(result){
            });

            // newSmsTmpl.html Input Setting
            $http.get('assets/jsons/input/smsInput.json')
            .then(function(result){
            	amoebaDataFactory.smsInput = result.data.data;
            	//console.log('smsInput');
            	//console.log(amoebaDataFactory.smsInput);
            },function(result){
            });

            // fileManagerTmpl.html Input Setting
            $http.get('assets/jsons/input/fileInput.json')
            .then(function(result){
            	amoebaDataFactory.fileInput = result.data.data;
            	//console.log('fileInput');
            	//console.log(amoebaDataFactory.fileInput);
            },function(result){
            });

            if(BOOL_USE_INTERFACE){
                // Trace Initialization
                UCAPP.UTILITY.TRACE.setEnableTrace(true);
                UCAPP.UTILITY.TRACE.setTimeStamp(true);
                UCAPP.UTILITY.TRACE.setTraceLevel(UCAPP.UTILITY.TRACE.TRACE_LEVEL.DETAIL);

                // Message callback function Registration between javascript and native
                app.setMessageCallback('uxclient_evt', function(name, args) {
                    ////console.log('setMessageCallback');
                    ////console.log("args: " + args);
                    var msgHeader = null;
                    try{
                        msgHeader = JSON.parse(args[0]);
                        ////console.log(msgHeader);
                    }
                    catch(e){
                        UCAPP.UTILITY.TRACE.printTrace(UCAPP.UTILITY.TRACE.TRACE_LEVEL.CRITICAL, args[0]);
                    }

                    var msgBody = null;
                    if(msgHeader.CmdType == "ipkts"){
                        try{
                            msgBody = JSON.parse(args[1]);
                        }
                        catch(e){
                            UCAPP.UTILITY.TRACE.printTrace(UCAPP.UTILITY.TRACE.TRACE_LEVEL.CRITICAL, args[1]);
                        }

                        UCAPP.IPKTS.UCTI.IPKTSProcess.ProcessIPKTSMsg(msgHeader, msgBody);
                    }
                    else if(msgHeader.CmdType == "ucs"){
                        try{
                            //console.log(args[1]);
                            msgBody = JSON.parse(args[1]);
                        }
                        catch(e){
                            UCAPP.UTILITY.TRACE.printTrace(UCAPP.UTILITY.TRACE.TRACE_LEVEL.CRITICAL, args[1]);
                        }

                        UCAPP.UC.UCProtocol.ProcessUCStdMsg(UCAPP.UC.UCMessageType.MESSAGE_FROM_STANDARD,
                            UCAPP.IPKTS.UCTI.UCCall_Common_Types._UCTI_UCLOGIN_CODE.RECV_DATA, msgBody, msgHeader);
                    }
                    else if(msgHeader.CmdType == "http"){ // 02
                        if(msgHeader.RequestID == "voicemail"){
                            UCAPP.UC.UCService.processDownloadVoicemail(args[1]);
                        }
                        else if(msgHeader.RequestID == "speed_dial"){
	                        UCAPP.HTTP.PBX_XML_NATIVE.processXMLMessage(args[1], msgHeader.RequestID);
                        }
                        else if(UCAPP.UC.UCProtocol.getStandardMode() == 0) { // 1 standard, 0 premium
                            UCAPP.HTTP.UCS_SOAP_NATIVE.processSOAPMessage(args[1], msgHeader.RequestID);
                        }
                        else if(UCAPP.UC.UCProtocol.getStandardMode() == 1) {
                            UCAPP.HTTP.PBX_XML_NATIVE.processXMLMessage(args[1], msgHeader.RequestID);
                        }
                        else{
                            UCAPP.UTILITY.TRACE.printTrace(UCAPP.UTILITY.TRACE.TRACE_LEVEL.CRITICAL, "CANNOT MATCH THE STANDARD OR PREMIUM");
                        }

                    }
                    else if(msgHeader.CmdType == "noti"){ // 0120hyosung
                        try{
                            msgBody = JSON.parse(args[1]);
                        }
                        catch(e){
                            UCAPP.UTILITY.TRACE.printTrace(UCAPP.UTILITY.TRACE.TRACE_LEVEL.CRITICAL, args[1]);
                        }

                        msgBody = JSON.parse(args[1]);
                        UCAPP.UI_EVENT.notiCallback(msgBody);
                    }
                    else if(msgHeader.CmdType == "notify"){ // 0212 hyosung
                        if(msgHeader.NotifyType != "2"){
                            try{
                                msgBody = JSON.parse(args[1]);
                            }
                            catch(e){
                                UCAPP.UTILITY.TRACE.printTrace(UCAPP.UTILITY.TRACE.TRACE_LEVEL.CRITICAL, args[1]);
                            }
                        }
                        else{
                            msgBody = args[1];
                        }
                        UCAPP.UI_EVENT.notifyCallback(msgHeader.NotifyType, msgBody);
                    }
                    else{
                        //UCAPP.UTILITY.TRACE.printTrace(TRACE.TRACE_LEVEL.CRITICAL, "CANNOT FIND MESSAGE HEADER TYPE");
                    }

                });

                // Dependencies Initialization
                UCAPP.IPKTS.UCTI.ConfMemberClass.initDependencies();
                UCAPP.IPKTS.UCTI.IPKTSProcess.initDependencies();
                UCAPP.IPKTS.UCTI.UCCall_Interface.initDependencies();
                UCAPP.UI_EVENT.setAmoebaDataFactory(amoebaDataFactory);

                UCAPP.UI_EVENT.initDependencies();
                UCAPP.UC.UCProtocol.initDependencies();
                UCAPP.UC.UCService.initDependencies();
                UCAPP.DBMS.DBInterface.initDependencies();

                // DBMS Command Creation
                UCAPP.DBMS.DBInterface.createCMD();

                UCAPP.HTTP.PBX_XML_NATIVE.initDependencies();
                UCAPP.HTTP.UCS_SOAP_NATIVE.initDependencies();

                UCAPP.UI.CallManager.initDependencies(); // 0205 hyosung
                UCAPP.UI.CallManager.setAmoebaDataFactory(amoebaDataFactory);

                UCAPP.UC.DATA.Conversation.initDependencies();
                UCAPP.UC.DATA.Conversation.setAmoebaDataFactory(amoebaDataFactory);

                UCAPP.UC.DATA.Contact.initDependencies(amoebaDataFactory);
                UCAPP.UC.DATA.Contact.setAmoebaDataFactory(amoebaDataFactory);

                UCAPP.NOTI.initDependencies();
                UCAPP.UI.ContactManager.initDependencies();
                UCAPP.SOUND.initDependencies();

	            amoebaDataFactory.defaultimage = UCAPP.UTILITY.BASE64_DEFAULT_IMAGE;
                amoebaDataFactory.defaultGroupImage = UCAPP.UTILITY.BASE64_DEFAULT_GROUP_IMAGE;
                amoebaDataFactory.defaultPhoneImage = UCAPP.UTILITY.BASE64_DEFAULT_PHONE_IMAGE;

                amoebaDataFactory.TRACE = UCAPP.UTILITY.TRACE;

                amoebaDataFactory.setAmoebaService(amoebaService);

                // Set Visibility Event Listener
                window.onfocus = function(){
                    console.log("front");
                    UCAPP.UTILITY.BOOL_IS_FOREGROUND = true;
                    UCAPP.UTILITY.BOOL_WAS_FOREGROUND = true;
                    UCAPP.UC.UCService.setFrontAndScreenSaver(false);
                    var notiCmdObj = {};
                    notiCmdObj[UCAPP.NOTI.NOTI_TYPE] = 3;
                    setTimeout(function(){
                        if(UCAPP.UTILITY.BOOL_IS_FOREGROUND){
	                        UCAPP.UTILITY.sendNotiCmd(notiCmdObj);
                        }
                    }, 500);
                    
                };
                window.onblur = function(){
                    console.log("background");
                    UCAPP.UTILITY.BOOL_IS_FOREGROUND = false;
                    setTimeout(function(){
                        UCAPP.UTILITY.BOOL_WAS_FOREGROUND = false;
                    }, 1000);
                };

                window.onerror = function(message, source, lineno, colno, error) {
                    /*
                     message: error message (string). Available as event (sic!) in HTML onerror="" handler.
                     source: URL of the script where the error was raised (string)
                     lineno: Line number where error was raised (number)
                     colno: Column number for the line where the error occurred (number)
                     error: Error Object (object)
                     */
                    var errorMessage = ("message: " + message);
                    errorMessage += ("source: " + source);
                    errorMessage += ("lineno: " + lineno);
                    errorMessage += ("colno: " + colno);

                    UCAPP.UTILITY.TRACE.printTrace(UCAPP.UTILITY.TRACE.TRACE_LEVEL.CRITICAL, errorMessage);
                };


                /*
	            $(document).keydown(function(e) {
		            if (e.which == 8 || e.keyCode == 8) {
                        //e.preventDefault();
                        $('#contents').focus();
                        //console.log("backspace key down");
		            }

	            });

                $(document).keyup(function(e) {
                    if (e.which == 8 || e.keyCode == 8) {
                        //e.preventDefault();
                        $('#contents').focus();
                        //console.log("backspace key down");
                    }

                });
                */

                $(document).on("keydown", function (e) {
                    if (e.which === 8 && !$(e.target).is("input:not([readonly]):not([type=radio]):not([type=checkbox]), textarea, [contentEditable], [contentEditable=true]")) {
                        e.preventDefault();
                    }
                });


	            /*
	            $(document).keydown(function(e) {
		            var nodeName = e.target.nodeName.toLowerCase();

		            if (e.which === 8) {
			            if ((nodeName == 'input' && (e.target.type == 'text' || e.target.type == 'password')) || nodeName == 'textarea'){
				            // do nothing
			            } else {
				            e.preventDefault();
			            }

		            }
	            });
	*/


                // Get Resource Folder
                UCAPP.UTILITY.getFolders().then(function(item){
                    //console.log("getFolders");
                    //console.log(item);
                    var folderInfo = item;
                    UCAPP.UTILITY.RESOURCE_DIR = folderInfo.Resource;
                    //console.log(UCAPP.UTILITY.RESOURCE_DIR);
                    UCAPP.UTILITY.SOUND_DIR = UCAPP.UTILITY.RESOURCE_DIR + "/interface/sounds/";

                    // wszResult = L"{\"Resource\":\"";
                    // wszResult += L"\", \"Home\":\"";
                    // wszResult += L"\", \"Data\":\"";
                });

                if(navigator.userAgent == "Macintosh"){
                    UCAPP.UC.UCService.setOSName("OSX");
                }
                else{
                    UCAPP.UC.UCService.setOSName("Windows");
                }


                // Get Common Setting Info;
                UCAPP.DBMS.DBInterface.openCommonDB().then(function(item){ // 0213 HYOSUNG
                    //console.log(item);
                    //UCAPP.UTILITY.USER_DIR = item;
                    if(item.result == false){
                        amoebaDataFactory.VERSION_ERROR = true;
                        amoebaDataFactory.PROGRAM_VERSION = item.version;
                    }
                    UCAPP.DBMS.DBInterface.get_login_settings().then(function(item) {
                        console.log(item);
                        if (item != false) {
                            var lang = item[0].str_language;
                            var datas = amoebaDataFactory.langInfo.data;
                            var fileName = "en";

                            for(var i in datas){
                                if(lang == datas[i].name){
                                    fileName = datas[i].fileName;
                                }
                            }
	                        amoebaDataFactory.SaveCount(item[0].int_max_conv, item[0].int_max_conv_log);

                            UCAPP.IPKTS.UCTI.IPKTSProcess.setPhoneVersion(item[0].str_program_version);
                            $http.get('assets/jsons/languages/'+fileName+'.json')
                                .then(function(result){
                                    amoebaDataFactory.global = result.data;
                                    amoebaDataFactory.langInfo.data[0].displayname = amoebaDataFactory.global.lang_english;
                                    amoebaDataFactory.langInfo.data[1].displayname = amoebaDataFactory.global.lang_kor;
                                    amoebaDataFactory.contactDataforPremium[0].name = amoebaDataFactory.global.lang_group_not_assigned;
                                    amoebaDataFactory.contactDataforPremium[1].name = amoebaDataFactory.global.lang_group_private;
                                    amoebaDataFactory.contactDataforStandard[0].name = amoebaDataFactory.global.lang_group_member;
                                    amoebaDataFactory.contactDataforStandard[1].name = amoebaDataFactory.global.lang_group_private;


                                    UCAPP.UI.ConvManager.initDependencies(amoebaDataFactory.global);
                                    UCAPP.UI.CallDataManager.initDependencies(amoebaDataFactory.global);

                                    UCAPP.UTILITY.sendLanguage(amoebaDataFactory.global);

                                   // amoebaService.goPage(-1);
                                },function(result){

                                });

                            var stLoginInfo = item[0];
                            UCAPP.UTILITY.setDebug(stLoginInfo.int_debugging_type, stLoginInfo.str_debugging_ip, stLoginInfo.str_debugging_port,
                                stLoginInfo.int_debugging_level, Number(stLoginInfo.bool_debugging_sip), Number(stLoginInfo.bool_debugging_javascript), Number(stLoginInfo.bool_debugging_media));
                        }
                    });
                    amoebaService.goPage(-1);
                });
            }
            else{
                amoebaService.goPage(-1);
            }
        }
    ]);
});