/**
 * Created by ehyolim on 2015-10-13.
 */
define(['ucApp'], function (ucApp) {
	ucApp.registerController(
		'loginCtrl',
		['$scope', '$state', '$rootScope', '$compile', '$http','$timeout', '$interval', 'amoebaService', 'amoebaDataFactory',
			function ($scope, $state, $rootScope, $compile, $http, $timeout, $interval, amoebaService, amoebaDataFactory) {
				//console.log("loginCtrl");
				amoebaDataFactory.setLoginScope($scope);

				// 로그인 세팅 팝업 띄우는 함수; 기본값 펄스
				$scope.loginSetting=false;

				// 로그인 세팅 안 드롭리스트
				$scope.serverADRS=false;
				$scope.language=false;
				$scope.service = amoebaService;
				$scope.factory = amoebaDataFactory;

				// 로그인 설정
				$scope.loginIDList=false; // id list dropdown
				$scope.copyMultiLoginProfiles = [];
				$scope.deleteMultiLoginProfiles = [];

				// Developer option
				$scope.bShowDevOpt = false;
				
				// Data Init - amoebaDataFactory
				$scope.loginData = {};
				$scope.multiLoginProfiles = amoebaDataFactory.multiLoginProfiles.data;
				$scope.langInfo = amoebaDataFactory.langInfo.data;
				angular.copy(amoebaDataFactory.loginInfo, $scope.loginData);

				// Login account init
				$scope.nowId = amoebaDataFactory.loginInfo.str_user_id.val;
				if($scope.loginData.bool_auto_login.val){
					//console.log($scope.loginData.str_user_pw.val);
					$scope.nowPwd = $scope.loginData.str_user_pw.val;
				}

				// Auto Login
				$scope.clickAutoLoginCheckbox = function(){
					$scope.loginData.bool_auto_login.val = !$scope.loginData.bool_auto_login.val;
					amoebaDataFactory.loginInfo = $scope.loginData;
					amoebaDataFactory.loginInfo.str_user_pw.val = $scope.nowPwd;
					amoebaDataFactory.applyLoginInfo(amoebaDataFactory.loginInfo);
				};

				$scope.setPassword = function(){
					$scope.nowPwd = $scope.loginData.str_user_pw.val;
				};

				$scope.login = function(){
					amoebaDataFactory.loginInfo.bool_first_login.val = false;
					if(amoebaDataFactory.loginInfo.str_server_ip.val == "" || amoebaDataFactory.loginInfo.str_server_ip.val == undefined){
						$scope.popupOpen(1, amoebaDataFactory.global.lang_empty_server_ip, $scope.endPopupForOK);
						amoebaDataFactory.loading = false;
						return;
					}

					if($scope.nowId != undefined && $scope.nowPwd != undefined){
						if($scope.nowId.length > 0 && $scope.nowPwd.length > 0){
							var bFlag = false;
							var iFindIdx = null;
							// check the id is in multiloginprofiles
							for(var idx in $scope.multiLoginProfiles){
								if($scope.nowId == $scope.multiLoginProfiles[idx].str_user_id.val
									&& $scope.loginData.str_server_ip.val == $scope.multiLoginProfiles[idx].str_server_ip.val){
									bFlag = true;
									iFindIdx = idx;
								}
							}

							if(bFlag){
								$scope.loginData.str_user_id.val = $scope.nowId;
								$scope.loginData.str_user_pw.val = $scope.nowPwd;

								$scope.loginData.strary_ccm_ip = $scope.multiLoginProfiles[iFindIdx].strary_ccm_ip.slice();
								$scope.loginData.str_lcm_ip.val= $scope.multiLoginProfiles[iFindIdx].str_lcm_ip.val;
								$scope.loginData.str_station_number.val = $scope.multiLoginProfiles[iFindIdx].str_station_number.val;

								amoebaDataFactory.saveLoginInfo($scope.loginData);
								amoebaDataFactory.loginToAmoeba();
							}
							else{
								if($scope.multiLoginProfiles.length > 9){
									$scope.openLoginHistory();
								}
								else{
									$scope.loginData.str_user_id.val = $scope.nowId;
									$scope.loginData.str_user_pw.val = $scope.nowPwd;

									$scope.loginData.strary_ccm_ip = [];
									$scope.loginData.str_lcm_ip.val = "";
									$scope.loginData.str_station_number.val = "";

									amoebaDataFactory.saveLoginInfo($scope.loginData);
									amoebaDataFactory.loginToAmoeba();
								}
							}
						}
						else{
							$scope.popupOpen(1, amoebaDataFactory.global.lang_empty_user_id_pw, $scope.endPopupForOK);
							amoebaDataFactory.loading = false;
						}
					}
					else{
						$scope.popupOpen(1, amoebaDataFactory.global.lang_empty_user_id_pw, $scope.endPopupForOK);
						amoebaDataFactory.loading = false;
					}
				};

				$scope.selectMultiId = function(strUserId, strServerIP){
					if($scope.nowID != strUserId){
						$scope.nowId = strUserId;
						$scope.nowPwd = "";
						$scope.loginData.bool_auto_login.val = false;
						$scope.loginIDList = false;
						$scope.changeLoginData(strUserId, strServerIP);
					}
				};
				
				$scope.changeLoginData = function(id, serverIP){
					var changeData = $scope.currentData(id, serverIP);
					$scope.loginData = {};
					if(angular.isDefined(changeData)){
						amoebaDataFactory.loginInfo.str_user_id.val = changeData.str_user_id.val;
						amoebaDataFactory.loginInfo.str_server_ip.val = changeData.str_server_ip.val;
						amoebaDataFactory.loginInfo.int_license_type.val = changeData.int_license_type.val;
						amoebaDataFactory.loginInfo.int_call_control.val = changeData.int_call_control.val;
						amoebaDataFactory.loginInfo.str_control_number.val = changeData.str_control_number.val;
						amoebaDataFactory.loginInfo.str_control_pw.val = changeData.str_control_pw.val;
						amoebaDataFactory.loginInfo.bool_use_linked_pair.val = changeData.bool_use_linked_pair.val;
						angular.copy(changeData.strary_ccm_ip, amoebaDataFactory.loginInfo.strary_ccm_ip);

						amoebaDataFactory.loginInfo.str_lcm_ip.val = changeData.str_lcm_ip.val;
						amoebaDataFactory.loginInfo.str_station_number.val = changeData.str_station_number.val;

						if(amoebaDataFactory.loginInfo.str_control_pw.val != ""){
							UCAPP.UTILITY.desChatText(amoebaDataFactory.loginInfo.str_control_pw.val).then(function(item){
								amoebaDataFactory.loginInfo.str_control_pw.val = item;
								$scope.$apply(function(){
									angular.copy(amoebaDataFactory.loginInfo, $scope.loginData);
								});

							});
						}
						else{
							angular.copy(amoebaDataFactory.loginInfo, $scope.loginData);
						}

					}
				};
				
				$scope.currentData = function(id, server){
					var multiData = $scope.multiLoginProfiles;
					var changeData;
					
					for(i in multiData){
						if(multiData[i].str_user_id.val == id && multiData[i].str_server_ip.val == server){
							changeData = multiData[i];
						}
					}
					return changeData
				};

				$scope.sendMail = function(){
					alert("send Mail");
				};
				
				// Login Language List Open
				$scope.openLangList = function(){
					$scope.language = !$scope.language;
				};
				
				// Login Language Set
				$scope.setLangVal = function(data){
					$scope.language = false;
					$scope.loginData.str_language.val = data;
				};

	            function getLangData(){

	            	var lang = $scope.loginData.str_language.val;
	            	var datas = $scope.langInfo;
	            	var fileName = "en";
	 
	            	for(var i in datas){
	            		if(lang == datas[i].name){
	            			fileName = datas[i].fileName;
	            		}
	            	}
	            	
	                $http.get('assets/jsons/languages/'+fileName+'.json')
	                    .then(function(result){
	                	    amoebaDataFactory.global = result.data;
			                $scope.langInfo[0].displayname = amoebaDataFactory.global.lang_english;
			                $scope.langInfo[1].displayname = amoebaDataFactory.global.lang_kor;
							amoebaDataFactory.contactDataforPremium[0].name = amoebaDataFactory.global.lang_group_not_assigned;
							amoebaDataFactory.contactDataforPremium[1].name = amoebaDataFactory.global.lang_group_private;
							amoebaDataFactory.contactDataforStandard[0].name = amoebaDataFactory.global.lang_group_member;
							amoebaDataFactory.contactDataforStandard[1].name = amoebaDataFactory.global.lang_group_private;

			                UCAPP.UTILITY.sendLanguage(amoebaDataFactory.global);

			                UCAPP.UI.ConvManager.initLanguage(amoebaDataFactory.global);
			                UCAPP.UI.CallDataManager.initLanguage(amoebaDataFactory.global);

	                    },function(result){

	                    });
	            }
				//getLangData();

				// 로그인 설정 오픈
				$scope.openLoginSetting = function(){
					$scope.loginSetting = true;
				};
				
				// 로그인 설정 닫기
				$scope.closeLoginSetting = function(){
					$scope.loginSetting = false;
					
					$scope.loginData = {};
					angular.copy(amoebaDataFactory.loginInfo, $scope.loginData);

				};

				// 로그인 설정 Apply
				$scope.loginSettingApply = function(id){ // 0212 HYOSUNG
					if($scope.loginData.int_call_control.val === 1
						&& ($scope.loginData.str_control_number.val.length === 0
						|| $scope.loginData.str_control_pw.val.length === 0)){
						$scope.popupOpen(1, "WITHOUT VOICE MODE NEED CONTROL NUMBER AND PASSWORD", function() {
							$scope.isDefaultPop = false;
						}, null);
					}
					else{
						// start ehyecha 2017.04.28
						if($scope.loginData.int_login_type.val == 0){
							amoebaDataFactory.SavePBXLoginOnly($scope.loginData.str_pbx_login_only_ip.val, $scope.loginData.str_pbx_login_only_stn.val, false);
							amoebaDataFactory.SaveUCLoginOnly(false);
							$scope.closeSetting();
						}
						else if($scope.loginData.int_login_type.val == 1){
							amoebaDataFactory.SavePBXLoginOnly($scope.loginData.str_pbx_login_only_ip.val, $scope.loginData.str_pbx_login_only_stn.val, false);
							amoebaDataFactory.SaveUCLoginOnly(true);
							$scope.closeSetting();
						}
						else{
							if($scope.str_pbx_login_only_ip == "" || $scope.pbxOnlyStation == ""){
								$scope.popupOpen(1, amoebaDataFactory.global.lang_login_pbx_line1, function() {
									$scope.isDefaultPop = false;

								}, null);
							}
							else{
								amoebaDataFactory.SavePBXLoginOnly($scope.loginData.str_pbx_login_only_ip.val, $scope.loginData.str_pbx_login_only_stn.val, true);
								amoebaDataFactory.SaveUCLoginOnly(false);
								$scope.closeSetting();
							}

						}
						// end ehyecha
					}
				};

				$scope.closeSetting = function(){
					$scope.loginSetting = false;
					amoebaDataFactory.loginInfo = $scope.loginData;
					amoebaDataFactory.applyLoginInfo(amoebaDataFactory.loginInfo);
					getLangData();
					amoebaDataFactory.SaveCount($scope.convCount, $scope.logCount); // 2017-05-08 save count

				};
				
				$scope.deleteHistory = function(id, server){
					var data = $scope.copyMultiLoginProfiles;
					for(var i in data){
						if(data[i].str_user_id.val == id && data[i].str_server_ip.val == server){
							$scope.deleteMultiLoginProfiles.push(data.splice(i, 1)[0]);
							break;
						}
					}
				};
				
				$scope.openLoginHistory = function(){
					$scope.deleteMultiLoginProfiles.splice(0);
					$scope.isPop='loginID';
					$scope.copyMultiLoginProfiles.length = 0;
					angular.copy($scope.multiLoginProfiles, $scope.copyMultiLoginProfiles);
				};
				
				$scope.okHistory = function(){
					$scope.isPop=false;
					if($scope.copyMultiLoginProfiles.length != $scope.multiLoginProfiles.length){
						$scope.multiLoginProfiles.length = 0;
						angular.copy($scope.copyMultiLoginProfiles, $scope.multiLoginProfiles);
						amoebaDataFactory.deleteLoginProfiles($scope.deleteMultiLoginProfiles.splice(0));
					}
				};

				$scope.cancelHistory = function(){
					$scope.isPop=true;
				};

				$scope.$on("$viewContentLoaded", function(event){ // 0229 hyosung
					//if(amoebaDataFactory.loginInfo.bool_first_login.val && amoebaDataFactory.VERSION_ERROR == false){
					if(amoebaDataFactory.loginInfo.bool_first_login.val){
						amoebaDataFactory.loginInfo.bool_first_login.val = false;
						//console.log("bool_first_login");
						if(amoebaDataFactory.loginInfo.bool_auto_login.val){

							$scope.login();
						}
					}
					amoebaDataFactory.checkForcedLogout();

					//amoebaDataFactory.checkNoNetwork();
					setTimeout(amoebaDataFactory.checkNoNetwork, 500, amoebaDataFactory);

					amoebaDataFactory.checkNoResponse();
					amoebaDataFactory.checkLinkInUse();
					amoebaDataFactory.closePhotoWindow();
					amoebaDataFactory.closeTextWindow();

					/*
					if(amoebaDataFactory.VERSION_ERROR){
						if(!amoebaDataFactory.SHOWN_VERSION_ERROR){
							amoebaDataFactory.SHOWN_VERSION_ERROR = true;
							var strFailMessage = amoebaDataFactory.global["lang_db_version_mismatch"];
							var strDBVersion = amoebaDataFactory.loginInfo.str_program_version.val;
							var strProgramVersion = amoebaDataFactory.PROGRAM_VERSION;

							strFailMessage = strFailMessage.replace(new RegExp('%1', 'g'), strProgramVersion);
							strFailMessage = strFailMessage.replace(new RegExp('%2', 'g'), strDBVersion);


							$scope.popupOpen(1, strFailMessage, function(){
								$scope.isDefaultPop = false; // 팝업 닫힘
								UCAPP.UTILITY.forceTerminate();
							});

						}
					}
					*/

					if($scope.loginData.int_login_type.val == 0){
						amoebaDataFactory.SavePBXLoginOnly($scope.loginData.str_pbx_login_only_ip.val, $scope.loginData.str_pbx_login_only_stn.val, false);
						amoebaDataFactory.SaveUCLoginOnly(false);
					}
					else if($scope.loginData.int_login_type.val == 1){
						amoebaDataFactory.SavePBXLoginOnly($scope.loginData.str_pbx_login_only_ip.val, $scope.loginData.str_pbx_login_only_stn.val, false);
						amoebaDataFactory.SaveUCLoginOnly(true);
					}
					else{
						amoebaDataFactory.SavePBXLoginOnly($scope.loginData.str_pbx_login_only_ip.val, $scope.loginData.str_pbx_login_only_stn.val, true);
						amoebaDataFactory.SaveUCLoginOnly(false);
					}

				});
				
				$(document).mouseup(function(e) {
					var container = $("#multiIdOpen");
					if (!container.is(e.target) && container.has(e.target).length === 0){
						$scope.$apply(function() {
							$scope.loginIDList = false;
						});
					}	
				});
				
				$("#nowPw").on('focusin keypress', function(e){
					 if(e.keyCode == 13){
						 $scope.$apply(function(){
							 $scope.login();
							 $("#nowPw").blur();
						 });
					 }
				});

				//팝업실행 함수
				$scope.popupOpen = function(no, msg, a, b){ // ok / ok,cancel 선택, 팝업내용, ok실행시 함수, cannel 실행시 함수
					var type = 'noti_OK';
					switch(no){
						case 1 :
							type = 'noti_OK';
							break;
						case 2 :
							type = 'noti_CANCLE';
					}

					msg = msg.replace(/\n/g, '<br>');
					$('#login_alert_msg').html(msg);

					$scope.isDefaultPop = type;
					//$scope.alert_MSG = msg;
					$scope.action = {"ok" : undefined, "cancel" : ""};
					$scope.action.ok = a;
					$scope.action.cancel = b;
				};

				$scope.test1 = function(){
					$scope.isDefaultPop = false; // 팝업 닫힘
				};

				$scope.endPopupForOK = function(){
					$scope.isDefaultPop = false;
				};

				// 로그인 기록 리스트 스크롤
				$scope.config1 = {
					autoHideScrollbar: true,
					theme: 'minimal-dark',
					advanced:{
						updateOnContentResize: true
					},
					setWidth: '100%',
					setHeight: '100%',
					axis: 'y',
					scrollInertia: 500
				};

				// 멀티 로그인 프로필 리스트
				$scope.config2 = {
					autoHideScrollbar: true,
					theme: 'minimal-dark',
					advanced:{
						updateOnContentResize: true
					},
					axis: 'y',
					setWidth: '100%',
					setHeight: $(this).parent().height(),
					scrollInertia: 500
				};

				// 팝업창 스크롤
				$scope.config3 = {
					autoHideScrollbar: true,
					theme: 'minimal-dark',
					advanced:{
						updateOnContentResize: true
					},
					axis: 'y',
					setWidth: '100%',
					setHeight: $(this).parent().height(),
					scrollInertia: 500
				};
			}
		]
	);
});

