/**
 * Created by ehyolim on 2015-10-13.
 */
define(['ucApp'], function (ucApp) {
	ucApp.registerController(
		'fileManagerCtrl',
		['$scope', '$state', '$rootScope', '$compile', '$timeout', 'amoebaDataFactory',
			function ($scope, $state, $rootScope, $compile, $timeout, amoebaDataFactory) {
				//console.log("fileManagerCtrl");
				$scope.factory = amoebaDataFactory;
				$scope.strSearchText = "";
				$scope.iSortType = 0;
				$scope.selectedTypeText = amoebaDataFactory.global.lang_all_files;
				$scope.selectSortType = function(iType){
					// iType
					// 0 : Select All, 1:Selct Recordings, 2:Select Voicemails
					$scope.iSortType = iType;
					if(iType == 0){
						$scope.selectedTypeText = amoebaDataFactory.global.lang_all_files;
					}
					else if(iType == 1){
						$scope.selectedTypeText = amoebaDataFactory.global.lang_recording;
					}
					else{
						$scope.selectedTypeText = amoebaDataFactory.global.lang_voicemail;
					}
					$scope.fileSort = false;
				};

				$scope.setFileData = function(){
					amoebaDataFactory.startFileManager().then(function(item){
						$scope.fileDatas = item;
					});
				};

				$scope.setFileDate = function(str_file_date){
					return moment(str_file_date).format("YYYY.MM.DD") + " "
							+ amoebaDataFactory.AmoebaService.setCurrentTime(str_file_date);
				};

				$scope.openFile = function(stFileData){
					//console.log("openFile");
					//console.log(stFileData);
					amoebaDataFactory.excuteFile(stFileData.int_file_type, stFileData.str_file_name).then(function(item){
						if(!item){
							amoebaDataFactory.showMainFail("lang_fail_to_open_file");
						}
					});
				};

				$scope.openFileFolder = function(){
					amoebaDataFactory.openFileFolder();
				};

				$scope.fileDatas = [
					/*
					{
						int_file_type : 1, // Recordings
						str_file_name : 'Picture_1d350707.jpg',
						str_file_size : '2000.1kb',
						str_file_date : '2017-11-11 03:00 pm'
					},
					{
						int_file_type : 2, // Voicemails
						str_file_name : 'Picture_1d350707.jpg',
						str_file_size : '2000.1kb',
						str_file_date : '2017-11-11 03:00 pm'
					}
					*/
				];

				// 파일 리스트 스크롤
				$scope.config1 = {
					autoHideScrollbar: true,
					theme: 'minimal-dark',
					advanced:{
						updateOnContentResize: true
					},
					setWidth: '100%',
					setHeight: $(this).parent().height(),
					scrollInertia: 500
				};

				// init To Do
				$scope.setFileData();
			}
////////////////////////////////////////////////////////////////////		app end
		]
	);
});