/**
 * Created by ehyolim on 2015-10-13.
 */
define(['ucApp'], function (ucApp) {
	ucApp.registerController(
		'smsManagerCtrl',
		['$scope', '$state', '$rootScope', '$compile', '$timeout', 'amoebaService', 'amoebaDataFactory',
			function ($scope, $state, $rootScope, $compile, $timeout, amoebaService, amoebaDataFactory) {
				//console.log("smsManagerCtrl");

				$scope.factory = amoebaDataFactory;
				$scope.picDatas =  amoebaDataFactory.pictureData;
				$scope.smsData = amoebaDataFactory.smsData;
				$scope.smsDateList = [];
				
				// sms들의 날짜 정보를 모은다
				$scope.getDateList = function(){
					var sms = $scope.smsData;
					
					for(var i = 0; i<sms.length; i++){
						var date = moment(new Date(sms[i].str_conv_datetime.val)).format('YYYY.MM.DD');
						if($scope.smsDateList.indexOf(date) == -1){
							$scope.smsDateList.push(date);
						}
					}
					
				};

				// br태그를 엔터로 변경한다
				$scope.changeBr = function(data){
					data.str_sms_content.val = data.str_sms_content.val.replace(/[<]br[>]/gi,'\n');
				};
				
				//총 사진 갯수
				$scope.isPhoto = function(data){
					data.picture_list = updatePic(data);
					var co = data.strary_sms_members_userkey.length;
					var result = 0;
					switch(co){
						case 0 :
							result = 1;
							break;
						case 1 :
							result = 1;
							break;
						case 2 :
							result = 2;
							break;
						case 3 :
							result = 3;
							break;
						default :
							result = 4;
							break;
					}
					data.photos = result;
				};
				
				//photo mapping
	   			function updatePic(datas){
	   				var list = [];
	   				var data = null;
	   				var picDatas = $scope.picDatas;


				    if(datas.strary_sms_members_userkey.length > 4){
					    data = datas.strary_sms_members_userkey.slice(0,4);
				    }
				    else{
					    data = datas.strary_sms_members_userkey;
				    }

				    //console.log(data);
				   // data = datas.strary_sms_members_userkey;

	   				for(var i = 0; i < data.length; i++){
   						if(data[i].indexOf("p") > -1){
   							list.push({"val" : picDatas[1].str_picture_data.val});
   						}
   						else{
   		   					for(var j = 0; j < picDatas.length; j++){
   		   						if(data[i] == picDatas[j].str_user_key.val){  							
   		   							list.push({"val" : picDatas[j].str_picture_data.val});
   		   							break;
   		   						}
								if(j == picDatas.length -1)
								{
									list.push({"val":amoebaDataFactory.defaultimage});
									break;
								}
   		   					}
   						}
   					}
	   				return list;
   				}

				$scope.updateSMSPic = function(datas){

					for(var i in datas){
						datas[i].picture_list = updatePic(datas[i]);
					}

				};

	   			$scope.deleteSms = function(data){
					amoebaDataFactory.deleteSMS(data.int_sms_id.val).then(function(item){
						var index = $scope.smsData.indexOf(data);

						$scope.smsData.splice(index, 1);
						amoebaDataFactory.smsData = $scope.smsData;

						$scope.smsDateList = [];
						$scope.getDateList();
					});
	   			};

				$scope.deleteSmsPopup = function(data){
					$scope.$emit('SMSDeletePopup', {"data" : data});
				};

				$scope.$on("deleteSMS", function(event, args){ // 0201 hyosung
					var data = args.data;
					$scope.deleteSms(data);
				});

				// sendingsms 팝업 호출
				$scope.sendingSMS = function(data){
					$scope.$emit('sendingSMS', { "data" : data, "type" : 0});
				};
				
				// send again 버튼 클릭
				$scope.sendAgainSms = function(data){ // 0224 hyosung
					$scope.smsUserList = [];
					for(var i=0; i<data.strary_sms_members_userkey.length; i++){

						var obj = {};
						angular.copy(amoebaDataFactory.smsBasicTemp, obj);

						obj.id = data.strary_sms_members_userkey[i];

						obj.name = amoebaService.getNameById(data.strary_sms_members_userkey[i]);

						obj.number = data.strary_sms_members_number[i];


						obj.numberList = amoebaService.getNumberList(data.strary_sms_members_userkey[i]);


						obj.type = data.strary_sms_members_type[i];
						//obj.typeName = amoebaService.getSmsType(obj.type);
						obj.deleteView = true;
						//obj.result = data.strary_sms_members_result[i];
						obj.result = '2';
						
						$scope.smsUserList.unshift(obj);
					}
	   				amoebaDataFactory.smsInfo = data;
	   				amoebaDataFactory.smsUserList = $scope.smsUserList;
	   				$scope.service.goPage(15);
				};

				$scope.$on("deleteAllSms", function(event, args){

					var smsTemp = {}
					angular.copy(amoebaDataFactory.smsDataBasicTemp, smsTemp);
					amoebaDataFactory.deleteAllSMS().then(function(item){
						amoebaDataFactory.smsData = [];
						amoebaDataFactory.smsInfo = {};
						amoebaDataFactory.smsUserList = [];
						$scope.smsData = null;
						$scope.smsDateList = [];
					});
				});

				amoebaDataFactory.startSMSManager().then(function(item){
					$scope.smsData = amoebaDataFactory.smsData;
					$scope.getDateList();
				});

				$scope.$on("$stateChangeStart", function(event, toState, toParams, fromState, fromParams){
					if(fromState.name == "main.newSms"){
						//console.log("change state from newSms to another");
					}
				});
				
				// sending sms 리스트 스크롤
	       		$scope.config1 = {
       				autoHideScrollbar: true,
       				theme: 'minimal-dark',
       				advanced:{
       					updateOnContentResize: true
       				},
       				setWidth: '100%',
       				setHeight: $(this).parent().height(),
       				scrollInertia: 500
	       		}
				
				// sms content 사진 업데이트
				$scope.$on("CHANGED_USER_PICTURE", function(event, args){
					//var userkey = args[0].str_user_key;
					var smsData = $scope.smsData;
					$scope.updateSMSPic(smsData);


				});
			}
		]
	);
});