define(['ucApp'], function(ucApp) {
    ucApp.registerProvider('routeDefs',
        ['$stateProvider', '$urlRouterProvider', '$couchPotatoProvider',
            function ($stateProvider, $urlRouterProvider, $couchPotatoProvider){
                this.$get = function () {
                    // this is a config-time-only provider
                    // in a future sample it will expose runtime information to the app
                    return {};
                };

                // $urlRouterProvider.otherwise('/');

                // States 정의
                $stateProvider
	            	//로그인 화면
	                .state('login',{
	                    url : '/',
	                    templateUrl:'app/modules/loginTmpl.html',
	                    controller:'loginCtrl',
	                    resolve:{
	                        dummy:$couchPotatoProvider.resolveDependencies(["modules/loginCtrl"])
	                    }
	                })
	                //메인화면
                    .state('main',{
                        url : 'main',
                        templateUrl:'app/modules/main/mainTmpl.html',
                        controller:'mainCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/mainCtrl"])
                        }
                    })
                    //컨텐츠화면
                    .state('main.content',{
                        url:'/content',
                        templateUrl : 'app/modules/main/content/contentTmpl.html',
                        controller:'contentCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/content/contentCtrl"])
                        }
                    })
                    //conversation group 만들기
                    .state('main.createconversation',{
                        url:'/conversation',
                        templateUrl : 'app/modules/main/conversation/createConversationTmpl.html',
                        controller:'createConversationCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/conversation/createConversationCtrl"])
                        }
                    })
                    //contact user 추가 및 선택
                    .state('main.addcontact',{
                        url:'/contact',
                        templateUrl : 'app/modules/main/contact/addContactTmpl.html',
                        controller:'addContactCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/contact/addContactCtrl"])
                        }
                    })
                    //user delete
                    .state('main.deletecontact',{
                        url : '/deleteuser',
                        templateUrl:'app/modules/main/contact/deleteContactTmpl.html',
                        controller:'deleteContactCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/contact/deleteContactCtrl"])
                        }
                    })
                    .state('main.chatcontent',{
                        url : '/chat',
                        templateUrl:'app/modules/main/content/chatContentTmpl.html',
                        controller:'chatContentCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/content/chatContentCtrl"])
                        }
                    })
                    //voiceMail
                    .state('main.voiceMail',{
                        url : '/voiceMail',
                        templateUrl:'app/modules/main/contact/voiceMailManagerTmpl.html',
                        controller:'voiceMailManagerCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/contact/voiceMailManagerCtrl"])
                        }
                    })
                    //sms
                    .state('main.sms',{
                        url : '/sms',
                        templateUrl:'app/modules/main/contact/smsManagerTmpl.html',
                        controller:'smsManagerCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/contact/smsManagerCtrl"])
                        }
                    })
                    //file
                    .state('main.file',{
                        url : '/file',
                        templateUrl:'app/modules/main/contact/fileManagerTmpl.html',
                        controller:'fileManagerCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/contact/fileManagerCtrl"])
                        }
                    })
                     //trans
                    .state('main.trans',{
                        url : '/trans',
                        templateUrl:'app/modules/main/content/transTmpl.html',
                        controller:'transCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/content/transCtrl"])
                        }
                    })
                    //calling
                    .state('main.calling',{
                        url : '/calling',
                        templateUrl:'app/modules/main/content/callingTmpl.html',
                        controller:'callingCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/content/callingCtrl"])
                        }
                    })
                    //calendar
                    .state('main.calendar',{
                        url : '/calendar',
                        templateUrl:'app/modules/main/conversation/calendarTmpl.html',
                        controller:'calendarCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/conversation/calendarCtrl"])
                        }
                    })
                    //callmemo
                    .state('main.callmemo',{
                        url : '/callmemo',
                        templateUrl:'app/modules/main/conversation/callmemoTmpl.html',
                        controller:'callmemoCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/conversation/callmemoCtrl"])
                        }
                    })
                    //userlist
                    .state('main.userlist',{
                        url : '/userlist',
                        templateUrl:'app/modules/main/conversation/userlistTmpl.html',
                        controller:'userlistCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/conversation/userlistCtrl"])
                        }
                    })
                    //new sms
                    .state('main.newSms',{
                        url : '/newSms',
                        templateUrl:'app/modules/main/contact/newSmsTmpl.html',
                        controller:'newSmsCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/contact/newSmsCtrl"])
                        }
                    })
                    //record
                    .state('main.record',{
                        url : '/record',
                        templateUrl:'app/modules/main/conversation/recordTmpl.html',
                        controller:'recordCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/conversation/recordCtrl"])
                        }
                    })
                    //add userList
                    .state('main.addUserlist',{
                        url : '/userlist',
                        templateUrl:'app/modules/main/conversation/userlistTmpl.html',
                        controller:'userlistCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/conversation/userlistCtrl"])
                        }
                    })
                    //add calluserList 
                    .state('main.addCallUserlist',{
                        url:'/calluserlist',
                        templateUrl : 'app/modules/main/conversation/callUserlistTmpl.html',
                        controller:'callUserlistCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/conversation/callUserlistCtrl"])
                        }
                    })
                    //add flex button 
                    .state('main.flexButton',{
                        url:'/flexButton',
                        templateUrl : 'app/modules/main/contact/flexButtonManagerTmpl.html',
                        controller:'flexButtonManagerCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/contact/flexButtonManagerCtrl"])
                        }
                    })
                    .state('main.testCode',{
                        url:'/testCode',
                        templateUrl : 'app/modules/main/contact/testCodeTmpl.html',
                        controller:'testCodeCtrl',
                        resolve:{
                            dummy:$couchPotatoProvider.resolveDependencies(["modules/main/contact/testCodeCtrl"])
                        }
                    })
            }
        ]
    );
});
