(function withAngular(angular) {
  'use strict';

  function ScrollBarsProvider() {
    this.defaults = {
      scrollButtons: {
        enable: false //enable scrolling buttons by default
      },
      axis: 'yx' //enable 2 axis scrollbars by default
    }

    // TODO: can we do this without jquery?
    $.mCustomScrollbar.defaults.scrollButtons = this.defaults.scrollButtons;
    $.mCustomScrollbar.defaults.axis = this.defaults.axis;

    this.$get = function ScrollBarsProvider() {
      return {
        defaults: this.defaults
      }
    }

  }

  function ScrollBarsDirective(ScrollBars) {
    return {
      scope: {
        ngScrollbarsConfig: '&'
      },
      /*
      compile: function (tElement, tAttrs, transClude){
        return {
          post:function postLink(scope, elem, attrs){
           // console.log(elem);
            //console.log("link");

            var defaults = ScrollBars.defaults;
            var configuredDefaults = $.mCustomScrollbar.defaults;

            var config = scope.ngScrollbarsConfig();
            if (!config) {
              config = {};
            }

            // apply configured provider defaults only if the scope's config isn't defined (it has priority in that case)
            for (var setting in defaults) {
              if (defaults.hasOwnProperty(setting)) {

                switch (setting) {

                  case 'scrollButtons':
                    if (!config.hasOwnProperty(setting)) {
                      configuredDefaults.scrollButtons = defaults[setting];
                    }
                    break;

                  case 'axis':
                    if (!config.hasOwnProperty(setting)) {
                      configuredDefaults.axis = defaults[setting];
                    }
                    break;

                  default:
                    if (!config.hasOwnProperty(setting)) {
                      config[setting] = defaults[setting];
                    }
                    break;

                }

              }
            }
            elem.mCustomScrollbar(config);

            // 0313 hyosung
            scope.$on('$destroy', function(){
              //console.log("scroll destroy");
              elem.mCustomScrollbar("destroy");
              //console.log("scroll destroyed");
            });

          }
        }
      }
      */
      link: function (scope, elem, attrs) {
        //console.log("scroll create");
        //console.log(elem);
        var defaults = ScrollBars.defaults;
        var configuredDefaults = $.mCustomScrollbar.defaults;

        var config = scope.ngScrollbarsConfig();
        //console.log(config);
        if (!config) {
          config = {};
        }

        // apply configured provider defaults only if the scope's config isn't defined (it has priority in that case)
        for (var setting in defaults) {
          if (defaults.hasOwnProperty(setting)) {

            switch (setting) {

              case 'scrollButtons':
                if (!config.hasOwnProperty(setting)) {
                  configuredDefaults.scrollButtons = defaults[setting];
                }
                break;

              case 'axis':
                if (!config.hasOwnProperty(setting)) {
                  configuredDefaults.axis = defaults[setting];
                }
                break;

              default:
                if (!config.hasOwnProperty(setting)) {
                  config[setting] = defaults[setting];
                }
                break;

            }

          }
        }
        elem.mCustomScrollbar(config);

        // 0313 hyosung


        /*
        scope.$on('$destroy', function(){
          console.log("scroll destroy");
          console.log(elem);
          elem.mCustomScrollbar('destroy');
          //console.log(temp);
          console.log("scroll destroyed");
        });
*/


      /*
        scope.$on('$stateChangeStart', function(){
          console.log("scroll start change");
          console.log(elem);
          elem.mCustomScrollbar('destroy');
          console.log("scroll start change");
        });
      */


      }
    };
  }

  angular.module('ngScrollbars', [])
    .provider('ScrollBars', ScrollBarsProvider)
    .directive('ngScrollbars', ScrollBarsDirective);

  ScrollBarsProvider.$inject = [];
  ScrollBarsDirective.$inject = ['ScrollBars'];

}(angular));