/**
 * Created by sunyongPark on 2015-10-23.
 */
// amoeba directives for amoeba style(css)
(function(angular) {
	var amoebaModule = angular.module('amoeba', []);
	amoebaModule.directive('amModal', function(){
		return {
			restrict: 'E',
			scope: {
				show: '='
			},
			replace: true, // Replace with the template below
			transclude: true, // we want to insert custom content inside the directive
			link: function(scope, element, attrs) {
				scope.dialogStyle = {};
				if (attrs.width)
					scope.dialogStyle.width = attrs.width;
				if (attrs.height)
					scope.dialogStyle.height = attrs.height;
				scope.hideModal = function() {
					scope.show = false;
				};
			},
			template:'<div class="am-modal" ng-show="show">'+
						'<div class="am-modal-overlay" ng-click="hideModal()"></div>'+
						'<div class="am-modal-dialog" ng-style="dialogStyle">'+
							'<div class="am-modal-close" ng-click="hideModal()">X</div>'+
							'<div class="am-modal-dialog-content" ng-transclude></div>'+
						'</div>'+
					'</div>'
		}
	});
	//conversatioon list directive
	amoebaModule.directive('amComversationList', function(){

		return {
			replace: true,
			restrict: 'A',
			template:
					'<li ng-init="isPhoto(data)">'+
						'<label class="dialog-chk">'+
						'<input type="checkbox" name="chk_info" ng-model="data.check" ng-change="stateChanged(data)"/>'+
						'<i ng-class="iconClass"></i>'+
					'</label>'+
					'<div ng-click="resetInt(data);sendChatAck(data);" ng-class="{1 : \'photo ea1\', 2 : \'photo ea2\', 3 : \'photo ea3\', 4 : \'photo ea4\'}[data.photos]">'+
					'<span am-photo-list ng-repeat="pData in data.picture_list"></span>'+
					'</div>'+
					'<dl ng-click="resetInt(data)">'+
						// START designIssue1 changwon 수정사항 적용
						'<dt class="fwb">' +
							'<em ng-hide="factory.memberLevel == \'STANDARD\' || data.int_conv_type.val == 6 || data.bool_is_group.val == false">{{data.int_conv_user.val + 1}}</em>' +
							'<em ng-hide="factory.memberLevel == \'STANDARD\' || data.int_conv_type.val == 6 || data.bool_is_group.val == true || data.str_session_key.val == \'\'"></em>' +
							'{{data.str_conv_name.val}}' + '<span class="date fwn">{{setNowtime(data.str_conv_datetime.val)}}</span>' +
						'</dt>'+
						// END designIssue1 changwon 수정사항 적용
					//	'<dt><em ng-hide="data.int_conv_type.val == 6">{{data.int_conv_user.val + 1}}</em>{{data.str_conv_name.val}} / {{data.int_conv_id.val}}<span class="date">{{setNowtime(data.str_conv_datetime.val)}}</span></dt>'+
						'<dd>'+
							'<p class="htmlArea">'+
//							'<span ng-class="{0 : \'recive\', 1 : \'send\', 2 : \'missed\', 4 : \'sms\', 7 : \'voice\', 8 : \'pic\', 9 : \'clip\', 10 : \'group\' , 11 : \'record\' }[data.conv_status.val]" ng-hide="data.int_conv_type.val == 3 || data.int_conv_type.val == 5 ||data.int_conv_type.val == 6"></span>'+
//							'{{data.str_conv_content.val}}'+
							'</p>'+
							'<div class="calling_time">00:00:00</div><em class="badge pp" ng-hide="data.int_new.val == 0">{{data.int_new.val}}</em>'+
						'</dd>'+
					'</dl>'+
				'</li>',
			link: function (scope, element, attrs) {

				var data = scope.data;

				scope.$watch("data.str_conv_content.val", function(){
					changeHtml();
				});
				
				function changeHtml(){

					var status = data.conv_status.val;
					var type = data.int_conv_type.val;
					var direction = data.int_conv_direction.val;
					var html = "";

					if(type != 3 && type != 5 && type != 6){
						switch (type) {
							case 0:
								html = "<span class='recive'></span>"
								break;
							case 1:
								if(direction == 1){
									html = "<span class='recive'></span>"
								}
								else{
									html = "<span class='send'></span>"
								}
								break;
							case 2:
								html = "<span class='missed'></span>"
									break;
							case 4:
								html = "<span class='sms'></span>"
									break;
							case 7:
								html = "<span class='voice'></span>"
									break;
							case 8:
								html = "<span class='pic'></span>"
									break;
							case 9:
								html = "<span class='clip'></span>"
									break;
							case 10:
								html = "<span class='group'></span>"
									break;
							case 11:
								html = "<span class='record'></span>"
									break;
						}
						
					}

					var text = data.str_conv_content.val.replace(/[<]br[>]/gi,' ');

					text = scope.service.encodeHTML(text);

					if(data.bool_is_group.val){
						if(data.strary_conv_members_userkey.length == 0){
							data.str_conv_name.val = scope.factory.global.lang_no_chat_members;
						}
					}

					element.find(".htmlArea").empty().html(html + text);
				}

				
				// 사진 변경 시
//				scope.$watch("data.strary_conv_members_userkey.length", function(){
//					scope.isPhoto(data);
//				});
				/*
				// 마우스오버 음영 처리
				var $list = $('.scrollable_wrap ul > li');
				var selectDialogChk = $list.parent().hasClass('im_dialogs_selectable');
				 
				$list.mouseenter(function () {
					$(this).toggleClass('iuhover', !selectDialogChk);
				})
				.mouseleave(function () {
					$(this).removeClass('iuhover', !selectDialogChk);
				});
				*/
			 }
		}
	});
//	'<span am-photo-list ng-repeat="pData in data.picture_list"></span>'+
	amoebaModule.directive('amPhotoList', function(){
		return {
			replace: true,
			restrict: 'A',
			template: '<span><img ng-src="{{pData.val}}" alt="photo" /></span>',
			link: function(scope, element){
			}
		}
	})
	amoebaModule.directive('amContactsGroupList', function(){

		return {
			template:
				'<div class="group-box" ng-class="{\'on\':gData.isGroup == true}">'+
					'<div class="group-title" ng-hide="searchContact.length > 1">'+
						'<label class="contact-chk" ng-hide="allCheck == false"  || factory.currentPage == \'8\'>'+
							'<input type="checkbox" name="chk_info" ng-model="gData.check" ng-change="contactAllUserCheck(gData)"/>'+
							'<i ng-class="iconClass"></i>'+
						'</label>'+
						'<button class="state-btn" ng-click="gData.isGroup = !gData.isGroup;">'+
							'<div>'+
								'<i class="" ng-class="{\'icon-angle-down\':gData.isGroup == true, \'icon-angle-up\':gData.isGroup == false}"></i>'+
								// START designIssue1 changwon 수정사항 적용
								//'<p class="fwb" ng-model="gData.name" title="{{gData.name}}" contenteditable={{gData.isEdit}} id={{gData.groupUI}} ng-focus="data.isEdit = true" ng-blur="closeGroupName(gData)">'+
								// END designIssue1 changwon 수정사항 적용
								//'{{gData.name}}</p>'+
								'<form class="tap1group" title="{{gData.name}}">'+
									'<input class="fwb" ng-model="gData.name" id={{gData.groupUI}} ng-blur="closeGroupName(gData)"'+
										'name = "{{factory.mainInput[75].name}}"'+
										'required = "{{factory.mainInput[75].required}}"'+
								        'ng-required = "{{factory.mainInput[75].ng_required}}"'+
					                    'ng-minlength = "{{factory.mainInput[75].ng_min_length}}"'+
				                         'maxlength = "{{factory.mainInput[75].max}}"'+
				                          'ng-pattern = "{{factory.mainInput[75].ng_pattern}}"'+
				                         'ng-trim = "{{factory.mainInput[75].ng_trim}}"'+
				                      '/>'+
				                '</form>'+
								'<span class="group-num" ng-show = "isUser(gData)">({{gData.count.val}})</span>'+
							'</div>'+
						'</button>'+
					'</div>'+
		            '<div class="group-list" ng-class="{\'type-large\':isPopupIcon==1, \'type-list\':isPopupIcon==3}">'+
						//'<ul><li am-contacts-user-list ng-repeat="uData in getUserList(gData.groupId) | orderBy: isOrderby" ng-mouseover="overMember(uData)" ng-mouseout="outMember()"><li></ul>'+
						'<ul><li am-contacts-user-list ng-repeat="uData in getUserList(gData.groupId) | orderBy: isOrderby" ng-hide=" (uData.str_im_status.val == \'0\' && viewAll == false && uData.int_user_type.val == 1 ) || (viewAll == false && ' +
							'uData.str_user_key.val.startsWith(\'p\') === true) || (uData.str_im_status.val == \'9999\' && viewAll == false && uData.int_user_type.val == 2 ) "><li></ul>'+

					'</div>'+
				'</div>'
			,restrict: 'A'
			,transclude : true
			,link: function(scope, element){
				/*
				scope.outMember = function(){
			    	scope.factory.isDragEnd = false;
				}
				
				scope.overMember = function(data){
					scope.factory.dragData = data;
					scope.factory.isDragEnd = true;
				}
				*/
			}
		}
	});
	//contact에서 user를 추가할때 리스트
	amoebaModule.directive('amContactsUserList', function(){

		return {
			template:
				'<li>'+
					'<label class="dialog-chk" ng-class="{dim : uData.isDim == true || uData.str_user_key.val == factory.userInfoData.str_my_key}" ng-hide="uData.str_speed_number != undefined">'+
						'<input type="checkbox" name="chk_info" ng-model="uData.check" ng-change="contactUserCheck(uData, false, false, false)"/>'+
						'<i ng-class="iconClass"></i>'+
					'</label>'+
					'<div ng-click="currentProfileFun(uData)" class="photo"><span ><img ng-src="{{uData.str_picture_data.val}}" alt="photo" /></span></div>'+
					'<i ng-click="currentProfileFun(uData)" ng-class = "service.getImStatusIcon(uData.str_im_status.val)" ng-hide="!service.checkIMUser(uData)"></i>'+
					'<dl ng-click="currentProfileFun(uData)">'+
						// START designIssue1 changwon 수정사항 적용
						'<dt class="fwb">'+
						// END designIssue1 changwon 수정사항 적용

							'<span class="call"><i ng-hide="service.checkPrivate(uData.str_user_key.val)" ng-class = "service.getPhoneStatusIcon(uData.str_phone_status.val)"></i></span>'+

							//'<span class="call"><i ng-hide="service.checkPrivate(uData.str_user_key.val) || isPopupIcon == 3" ng-class = "{\'0\' : \'icon_state state1\', \'1\' : \'icon_state state2\', \'2\' : \'icon_state state3\', \'3\' : \'icon_state state4\', \'4\' : \'icon_state state5\'}[uData.str_phone_status.val]"></i></span>'+

							'{{uData.str_first_name.val}}'+
						'</dt>'+
						'<dd>'+
							'<p ng-if="uData.str_today_user_message.val == \'\' || uData.str_im_status.val == 0 || uData.str_im_status.val == 10 || uData.str_im_status.val == null" ng-hide="uData.str_im_status.val == null">{{service.getImStatusText(uData.str_im_status.val)}}</p>'+
							'<p ng-if="uData.str_today_user_message.val != \'\' && uData.str_im_status.val != 0 && uData.str_im_status.val != 10">{{uData.str_today_user_message.val}}</p>'+
						'</dd>'+
					'</dl>'+
				'</li>',
			replace: true,
			restrict: 'A',
			link: function(scope, element){
				/*
				var $list = $('.group-list ul > li');
		        var selectDialogChk = $list.parent().hasClass('im_dialogs_selectable');
//		        var dummy = $('#dragDummy');

		         $list.mouseenter(function () {
		                 $(this).toggleClass('iuhover', !selectDialogChk);
		             })
		             .mouseleave(function () {
		                 $(this).removeClass('iuhover', !selectDialogChk);
		             });
		             */
			}
		}
	});
	
	//contact에서 group list
	amoebaModule.directive('amContactGroupList', function(){

		return {
			template: '<li title="{{gData.name}}"><span>{{gData.name}}</span></li>',
			replace: true
		}
	});

	//contact에서 search option list
	amoebaModule.directive('amContactSearchList', function(){

		return {
			template:
			'<div class="group-box" ng-show = "isSearchUser(gData)" ng-class="{\'on\':gData.isGroup == true}">'+
			'<div class="group-title" >'+
			'<label class="contact-chk" ng-hide="allCheck == false || factory.currentPage == \'8\' || searchContact!=\'\'">'+
			'<input type="checkbox" name="chk_info" ng-model="gData.check" ng-change="contactAllUserCheck(gData)"/>'+
			'<i ng-class="iconClass"></i>'+
			'</label>'+
			'<button class="state-btn" ng-click="gData.isGroup = !gData.isGroup;">'+
			'<div>'+
			'<i class="" ng-class="{\'icon-angle-down\':gData.isGroup == true, \'icon-angle-up\':gData.isGroup == false}"></i>'+
			// START designIssue1 changwon 수정사항 적용
			//'<p class="fwb" ng-model="gData.name" title="{{gData.name}}" contenteditable={{gData.isEdit}} id={{gData.groupUI}} ng-focus="data.isEdit = true" ng-blur="closeGroupName(gData)">'+
			// END designIssue1 changwon 수정사항 적용
			//'{{gData.name}}</p>'+
			'<form class="tap1group" title="{{gData.name}}">'+
			'<input class="fwb" ng-model="gData.name" id={{gData.groupUI}}'+
			'name = "{{factory.mainInput[75].name}}"'+
			'required = "{{factory.mainInput[75].required}}"'+
			'ng-required = "{{factory.mainInput[75].ng_required}}"'+
			'ng-minlength = "{{factory.mainInput[75].ng_min_length}}"'+
			'maxlength = "{{factory.mainInput[75].max}}"'+
			'ng-pattern = "{{factory.mainInput[75].ng_pattern}}"'+
			'ng-trim = "{{factory.mainInput[75].ng_trim}}"'+
			'/>'+
			'</form>'+
			'<span class="group-num" ng-show = "isSearchUser(gData)">({{gData.icount.val}})</span>'+
			'</div>'+
			'</button>'+
			'</div>'+
			'<div class="group-list" ng-class="{\'type-large\':isPopupIcon==1, \'type-list\':isPopupIcon==3}">'+
			'<span ng-hide="isSearchUser(gData)"  class="text-gray">{{factory.global.lang_html_nomember}}</span>' +
			//'<ul><li am-contacts-user-list ng-repeat="uData in getUserList(gData.groupId) | orderBy: isOrderby" ng-mouseover="overMember(uData)" ng-mouseout="outMember()"><li></ul>'+
			'<ul><li am-contacts-user-list ng-repeat="uData in getSearchUserList(gData.groupId)"><li></ul>'+
			//'<span ng-hide="isSearchUser(gData)"  class="text-gray">{{factory.global.lang_html_nomember}}</span>' +

			'</div>'+
			'</div>'
			,restrict: 'A'
			,transclude : true
			,link: function(scope, element){
				/*
				 scope.outMember = function(){
				 scope.factory.isDragEnd = false;
				 }

				 scope.overMember = function(data){
				 scope.factory.dragData = data;
				 scope.factory.isDragEnd = true;
				 }
				 */
			}
		}
	});

	//contact에서 group list
	amoebaModule.directive('amContactGroupEditList', function(){

		return {
			template: '<li title="{{eData.name}}"><span>{{eData.name}}</span></li>',
			replace: true
		}
	});

	amoebaModule.directive('amContentNoticeResult', function(){

		return {
			template:
				'<tr>'+
					'<td class="mail"><p>{{noticeData.str_conv_name.val}}</p></td>'+
					'<td class="cont"><p>{{noticeData.str_conv_log_content.val}}</p></td>'+
					// START designIssue1 changwon 수정사항 적용
					'<td class="time fwb">{{currentDate(noticeData.str_conv_log_datetime.val)}}</td>'+
					// END designIssue1 changwon 수정사항 적용
				'</tr>',
			replace: true,
			restrict: 'A',
			link: function(scope, element){
			}
		}
	});
//	ng-class="{true : \'bg_green bdt_green-a\', false : \'bg_blue bdt_blue-a\'}[status]"
	amoebaModule.directive('amChatMessageList', function(){
		return {
			template:
				'<li ng-init = "chatSet(callData)" ng-class="{0 : \'notice_msg\', 1 : \'in text\', 2 : \'in image\', 3 : \'in file\', 4 : \'in call\', 5 : \'in call\', 6 : \'in voice\', 7 : \'in record\', 8: \'out text\', 9 : \'out image\', 10 : \'out file\', 11 : \'out call\', 12 : \'out call\', 13 : \'out voice\', 14 : \'out record\', 15 : \'invite_msg\', 16:\'in call\'}[callData.int_conv_UI.val]">'+
				// <!--
				// notice_msg 날짜 폼
				// in 들어오는 메세지
				// out 나가는 메세지
				// text
				// image
				// file
				// call
				// voice
				// record
				// + loading = 전송중 노트 sms im
				// + failure = 전송실패
				// + sending = 전송중 파일 이미지

				// ex ) 받은 이미지             in  image
				//      보내는 메세지           out text
				//      보내는 메세지 전송중일때 out text loading
				//      보내는 메세지 전송중실패 out text failure
				// 로 메세지명 변경-->

					'<div class="photo clickCursor" ng-click="openProfile(callData)">'+
						'<img ng-src="{{callData.picture}}" alt="{{callData.str_conv_name.val}}">'+
					'</div>'+
					'<table class="table_wrap">'+
						'<tr>'+
							'<td class="out-margin"></td>'+
							'<td>'+
								'<button class="nth_repeat"><i class="icon-repeat"></i></button>'+
								'<button class="nth_times"><i class="icon-times"></i></button>'+
								'<button class="nth_loading"><i class="icon-loading"></i></button>'+
								'<table class="table_wrap_1">'+
									'<tr class="topitem">'+
										'<td>'+
											'<div>'+
											'<span title="{{callData.str_conv_name.val}}">{{callData.str_conv_name.val}}</span>'+
											'<em>{{currentTime(callData.str_conv_log_datetime.val)}}</em>'+
											'</div>'+
										'</td>'+
									'</tr>'+
									'<tr class="contentitem text">'+
										// <!-- 텍스트  -->
										'<td class=""><div class="chatHtml" ng-class="{\'mw\':callData.int_conv_log_direction.val == 1}"></div></td>'+
									'</tr>'+
									'<tr class="contentitem image ">'+
										// <!-- 이미지 -->
										// <!--
										// type1 가로로 긴 이미지
										// type2 새로로 긴 이미지
										// -->
										'<td><em><img src="assets/images/contents/chat/imgfile_2.png" alt=""></em></td>'+
									'</tr>'+
									'<tr class="contentitem file">'+
										// <!-- 파일 -->
										'<td><div>'+
											'<button><i></i>{{callData.str_file_name.val}}<i></i></button>'+
										'</div></td>'+
									'</tr>'+
									'<tr class="contentitem call" ng-class="{ 4 : \'missedcall\', 5 : \'incall\', 11 : \'incall\', 12 : \'outcall\', 16 : \'callback\'}[callData.int_conv_UI.val]">'+
										// <!-- 전화 -->
										// <!--
										// incall + end
										// outcall + end
										// groupcall + end
										// missedcall(미스드콜만 들어오는 메세지)
										// -->
										'<td>'+
											'<div>'+
											'<em><i></i>{{factory.global.lang_incomming_call}}</em>'+
											'<em><i></i>00:00:00</em>'+
											'</div>'+
											'<div>'+
											'<em><i></i>{{factory.global.lang_outgoing_call}}</em>'+
											'<em><i></i>00:00:00</em>'+
											'</div>'+
											'<div>'+
											'<em><i></i>Group Call</em>'+
											'<em><i></i>00:00:00</em>'+
											'</div>'+
											'<div>'+
											'<em><i></i>{{factory.global.lang_missed_call}}</em>'+
											'<em><i></i>00:00:00</em>'+
											'</div>'+
											'<div>'+
											'<em><i></i>{{factory.global.lang_callback_done}}</em>'+
											'<em><i></i>00:00:00</em>'+
											'</div>'+
										'</td>'+
									'</tr>'+
									'<tr class="contentitem voice" ng-class="{play : callData.voicemail_form == true}" ng-init="service.setVoiceDefault(callData)">'+
										// <!-- 보이스메일 -->
										// <!--
										// 기본   재생전,
										// play  재생후
										// stop  다운로드 시       -->

										'<td>'+
											'<div>'+
												//'<span class="con1"><em><i></i>{{factory.global.lang_html_voice}}({{callData.str_file_name.val}})</em></span>'+
												'<span class="con1"><em><i></i>{{factory.global.lang_html_voice}}</em></span>'+
												//'<span class="con1"><i></i>{{factory.global.lang_html_voice}}({{callData.str_file_name.val}})</span>'+
												'<em class="con2"><span>{{callData.play_time}}</span><span>{{callData.str_conv_log_duration.val.split(".")[0]}}</span></em>'+
													// changwon edit issue154 ng-if 삭제
												'<span class="con3"><button ng-click="service.voiceMailStart(callData)"><i></i></button></span>'+
													// '<span class="con3" ng-if="callData.isVoicemail_play == true"><button ng-click="service.stopVoice(callData)"><i></i></button></span>'+
											'</div>'+
											'<div>'+
												'<em class="con1" ng-if="callData.bool_conv_log_download.val == 0"><button ng-click="service.downVoice(callData)">Download <i></i></button></em>'+
												'<em class="con1" ng-if="callData.bool_conv_log_download.val == 1"><button ng-click="service.downVoice(callData)">Downloaded <i></i></button></em>'+
												'<em class="con2">'+
													'<em class="gauge_wrap">'+
														'<em class="gauge_in" ng-style="callData.width"><i class="icon-circle"></i></em>'+
													'</em>'+
													'<button><i></i></button>'+
												'</em>'+
											'</div>'+
										'</td>'+
									'</tr>'+
									'<tr class="contentitem record">'+
										// <!-- 레코딩
										// 기본
										// play
										// -->
										'<td>'+
											'<div>'+
												'<span class="con1"><i class="icon-circle"></i>Call Recording</span>'+
												'<em class="con2"><span>01:16</span>'+
												'<span class="con3">00:02:35</span></em>'+
												'<span class="con4"><button><i></i></button></span>'+
												'<em class="con5">'+
													'<em class="gauge_wrap">'+
														'<em class="gauge_in"><i class="icon-circle"></i></em>'+
													'</em>'+
													'<i></i>'+
												'</em>'+
											'</div>'+
										'</td>'+
									'</tr>'+
								'</table>'+
							'<div class="sending"><span>Sending...</span><em class="gauge_wrap"><em class="gauge_in"></em></em><button><i></i></button></div>'+
							'</td>'+
							'<td class="in-margin"></td>'+
						'</tr>'+
					'</table>'+
					'<span class="notice">{{service.setTime(callData.str_conv_log_datetime.val)}}</span>'+
					'<span class="invite">{{callData.str_conv_log_content.val}}</span>'+
				'</li>',
				/*'<em ng-class="callData.int_conv_log_direction.val == 2 ? chatClass : \'\'">'+*/
			replace: true,
			restrict: 'A',
			link: function (scope, element, attrs) {
				var html = scope.changeEmoticon(scope.callData.str_conv_log_content.val);

				//html = scope.service.encodeHTML(html); // this code need to inspect more for abnormal case
				html = html.replace(/\n/g, '<br>');
				element.find(".chatHtml").html(html);
	        }
		}
	});
	
	amoebaModule.directive('amPhoneList', function(){
		return{
			template :
				'<p>{{nData}}</p>'
			, restrict: 'A'
			, link: function(scope, element){
//				scope.selectedList = function(data){
//					 scope.parent.selectedPhone = data;
//					 scope.parent.isDrop = false;
//				}
//				//console.log(scope);
//				var p = $('#selectedNum');
//				var c = $('#selectedAn');
//				element.on('click', function(){
//					
//					if(p.hasClass('MD1-num1Box on')){
//						
//						p.removeClass("on");
//						if(c.hasClass("MD1-num1_i icon-caret-up")){
//							c.removeClass("icon-caret-up").addClass("icon-caret-down");
//						}
//						
//					} else {
//						
//						p.addClass("on");
//						if(c.hasClass("MD1-num1_i icon-caret-down")){
//							c.removeClass("icon-caret-down").addClass("icon-caret-up")
//						}
//					}
//					scope.parent.selectedPhone = scope.$parent.nData;					
//					p.find('p').text(scope.$parent.nData); 
//	            });
			}
		}
	});
	amoebaModule.directive('amContactUserList', function(){
		return {
			template:
				'<tr>'+
					'<td>'+
						'<div class="photo">'+
							'<img ng-src="{{service.SearchUserPic(cUserData)}}" alt="사진">'+
						'</div>'+
						'<i ng-class="service.getImStatusIcon(cUserData.str_im_status.val)"  ng-hide="!service.checkIMUser(cUserData)"></i>'+
					'</td>'+
					'<td>'+
						// START designIssue1 changwon 수정사항 적용
						'<p class="fwb">{{cUserData.str_first_name.val}}</p>'+
						// END designIssue1 changwon 수정사항 적용
						'<p>{{cUserData.str_cellular_phone.val}}</p>'+
					'</td>'+
					'<td>'+
						// START designIssue1 changwon 수정사항 적용
						'<p class="fwb">{{cUserData.str_desk_phone1.val}}<i ng-class="service.getPhoneStatusIcon(cUserData.str_phone_status.val)"></i></p>'+
						// END designIssue1 changwon 수정사항 적용
						'<p>{{cUserData.str_email_address1.val}}</p>'+
					'</td>'+
					'<td>'+
						'<button class="Mbtn" ng-click="addUserPop(cUserData)" ng-class ="{dim : cUserData.isAdd == \'Added\' || cUserData.str_user_key.val == ownerInfo.str_user_id.val}">{{factory.global.lang_add}}</button>'+
					'</td>'+
				'</tr>',
			replace: true,
			restrict: 'A',
			link: function(scope, element){
				/*
				var $list = $('#contact-list tbody > tr');
//		        var selectDialogChk = $list.parent().hasClass('im_dialogs_selectable');
//
//
		        $list.mouseenter(function () {
		                $(this).toggleClass('iuhover', !selectDialogChk);
		            })
		            .mouseleave(function () {
		                $(this).removeClass('iuhover', !selectDialogChk);
		            });
		            */
			}
		}

	})
		//delete/move/ivite user
	amoebaModule.directive("amContactDeleteUser", function(){
		return {
			template :
			'<div ng-init="data=tData" class="MD1-userCard" ng-class="tData.selectedtype" ng-click="selectUserFunc(tData)">'+
//			{\'type_10\' : tData.str_user_key.val==\'dummy\', \'type_4\' : tData.str_user_key.val != \'dummy\'}
				'<div class="MD1-topZone" >'+
					'<div class="MD1-xBox">'+
						'<button ng-click="unSelect(tData)"><i></i></button>'+
					'</div>'+
					'<div class="MD1-soundBox" >'+
						'<label class="MD1-chk1"><input type="checkbox" name="MD1-chk1"  ng-checked="tData.mute" ng-click="userMute(tData)"><i ng-show ="tData.onmute == true"  ng-class="{\'icon-microphone\':tData.mute == false ,\'icon-microphone-off\':tData.mute == true}"></i></label>'+
					'</div>'+
				'</div>'+
				'<div class="MD1-middleZone">'+
					'<div class="MD1-checkBox">'+
						'<label class="MD1-chk2"><input type="checkbox" name="MD1-chk2" ng-model="tData.check"><i ng-class="icon"></i></label>'+
					'</div>'+
					'<div class="MD1-photoBox" ng-click="openProfile(tData)" ng-class="{\'clickCursor\' : tData.str_user_key.val != factory.userInfoData.str_my_key && factory.getCurrentState() == \'main.userlist\'}">'+
					//'<div class="MD1-photoBox">'+
						'<img ng-src="{{service.currentPic(tData)}}" alt="사진">'+
						'<em class="nth_1" ng-class="onlybgClass" ng-show="tData.callCheck==true"></em>'+
						'<em class="nth_2"></em>'+
					'</div>'+
					'<div class="MD1-stateBox">'+
						'<i ng-class="service.getImStatusIcon(tData.str_im_status.val)" ng-hide ="tData.int_user_type.val != 1"></i>'+
					'</div>'+
				'</div>'+
				'<div class="MD1-bottomZone">'+
					'<div class="MD1-name1Box">'+
						'<p>{{tData.str_first_name.val}}</p>'+
					'</div>'+
					'<div class="MD1-num1Box" id="selectedNum" ng-click="isDropMenu(tData)" ng-class="{\'on\' : tData.isDrop == true}">'+//ng-click="MD1_userCard=!MD1_userCard" ng-class="{\'on\':MD1_userCard==true}">'+
						'<div class="MD1-numBox_inw">'+
							'<i ng-class = "service.getPhoneStatusIcon(tData.str_phone_status.val)"></i>'+
						//'<p>{{tData.selectedPhone}}</p><i class="MD1-num1_i icon-caret-down" id="selectedAn"></i>'+ //ng-class="{\'icon-caret-up\':MD1_userCard==true,\'icon-caret-down\':MD1_userCard==false}" ng-init="MD1_userCard=false"></i>'+
				// changwon edit 0315 p태그에 data-text부분 추가
							'<p data-text="{{factory.global.lang_no_info}}" >{{tData.selectedPhone}}</p><i class="MD1-num1_i icon-caret-down" id="selectedAn" ng-hide ="tData.showNum == false"></i>'+ //ng-class="{\'icon-caret-up\':MD1_userCard==true,\'icon-caret-down\':MD1_userCard==false}" ng-init="MD1_userCard=false"></i>'+
						'</div>'+
					'</div>'+
					'<div class="MD1-num2Box" ng-hide ="tData.showNum == false">'+
						//'<p class="MD1-dropList" ng-repeat="nData in tData.phoneArr" ng-click="closeMenu(tData, nData)">{{nData}}</p>'+
						'<p data-text="{{factory.global.lang_no_info}}" class="MD1-dropList" ng-repeat="nData in tData.phoneArr track by $index" ng-click="closeMenu(tData, nData)">{{nData}}</p>'+
						'</div>'+

						'<div class ="MD1-numBox-private" ng-click="isDropNumMenu(tData)" ng-class="{\'on\' : tData.isNumDrop == true}">'+
						//'<ul class="recentSort_menu">' +
						//'<li>' +
						//'<i class="icon-angle-up"></i>' +
						//'<i class="icon-angle-down"></i>' +
						//'<ul>' +
						'<p title="{{numtype}}">{{numtype}}</p><i class="icon-caret-down" id="selectedAn"></i>'+
						'</div>'+
			            '<div class="MD1-numBox-privatenumlist" >' +
						'<p am-num-drop-down-list title="{{numDrop}}"  class="MD1-dropList" ng-repeat="numDrop in numDropDown" ng-click="closeNumMenu(tData,numDrop)">{{numDrop}}</p>' +

						//'</div>'+
			 			'</div>' +
						'<div class="privateinputBox" ng-click="isDropNumSelect(tData)" ng-class="{\'on\' : tData.isNumSelect == true}">' +
						'<input type="text" ng-model="tData.selectedPhone" class="inputselectedphone"></input>' +
						'<i class="icon-caret-down" id="selectedAn" ng-hide ="tData.showNum == false"></i>'+
						'</div>' +
						'<div class="MD1-numBox-privatenumberlist" ng-hide ="tData.showNum == false">'+
						'<p class="MD1-dropList" ng-repeat="nData in tData.phoneArr track by $index" ng-click="closeSelectMenu(tData, nData)">{{nData}}</p>'+
						//'<input type="text" ng-blur="SaveNumber(tData)" ng-model="newnumber" class = "inputnewnum" onkeyup="this.value=this.value.replace(/[^0-9 *#]/g,\'\')" / >' +
						'</div>'+
						//'<input type="text" ng-blur="SaveNumber(tData)" ng-model="newnumber" class = "inputnewnum" onkeyup="this.value=this.value.replace(/[^0-9 *#]/g,\'\')" / >' +
						'<input type="text" name="conumber2" class="co" value="CO"  ng-show= "tData.isStation == false"  onkeyup="this.value=this.value.replace(/[^0-9 *#]/g,\'\')"' +
						'ng-model="tData.conumber"' +
						'name = "{{factory.mainInput[11].name}}"' +
						'required = "{{factory.mainInput[11].required}}"' +
						'ng-required = "{{factory.mainInput[11].ng_required}}"' +
						'ng-minlength = "{{factory.mainInput[11].ng_min_length}}"' +
						'maxlength = "{{factory.mainInput[11].max}}"' +
						'ng-pattern = "{{factory.mainInput[11].ng_pattern}}"' +
						'ng-trim = "{{factory.mainInput[11].ng_trim}}"' +
						'>' +

						//' <input type="text" name="stationnumber" class="station" ng-show= "isStation == true" value ="{{tData.selectedPhone}}" readonly>'+ //ng-class="{\'icon-caret-up\':MD1_userCard==true,\'icon-caret-down\':MD1_userCard==false}" ng-init="MD1_userCard=false"></i>'+
						//' <input type="text" name="conumber1" class="co"  ng-hide= "isStation == true">' +
						//' <input type="text" name="conumber2" class="co"  ng-hide= "isStation == true">' +
						//'</div>' +
						//'</ul>' +
						//'</li>' +
						//'</ul>' +

					'<div class="MD1-name2Box" ng-hide ="tData.int_user_type.val != 1">'+
						'<p>{{tData.str_office_department.val}}</p>'+
					'</div>'+
					'<div class="MD1-btnBox">'+
						'<button class="MD1-btn1" ng-click="inviteBtn(tData)">{{factory.global.lang_out}}</button>'+
						'<button class="MD1-btn2"ng-click="outBtn(tData)">{{factory.global.lang_invite}}</button>'+
					'</div>'+
				'</div>'+
				'<div class="MD1-backgroundZone" ng-class="bdClass">'+
					'<div class="MD1-UIH">'+
						'<span>{{factory.global.lang_user_images_here}}</span>'+
					'</div>'+
					'<div class="MD1-MSM1">'+
					// START changwon edit 160329  i태그 삭제
					'<button ng-click="multiPage()"></button>'+
					// END changwon edit 160329
					'<span>{{factory.global.lang_multi_select_mode1}}</span>'+
					'</div>'+
					'<div class="MD1-MSM2">'+
					// START changwon edit 160329  i태그 삭제
					'<button ng-click="multiPage()"></button>'+
					// END changwon edit 160329
					'<span>{{factory.global.lang_multi_select_mode2}}</span>'+
					'</div>'+
					'</div>'+
					'</div>',

				replace: true,
				restrict: 'A',
				link: function(scope, attr, element){
					//scope.data,scope

					var tData = scope.tData;
					var systemtype = scope.factory.memberStorageLevel;
					// 유저 리스트 카드 뮤트 값 변경
					tData.mute = false;
					scope.userMute = function(data){
						data.mute = data.mute;
						//console.log(data.selectedPhone);
						scope.factory.muteMember(data).then(function(result){
							if(result != false) {
								if(result === 1){
									scope.factory.printTrace("unmute");
									scope.factory.printTrace(data.mute);
									data.mute =false;
									scope.factory.printTrace(data.mute);
								}
								else if(result === 2){
									scope.factory.printTrace("mute");
									scope.factory.printTrace(data.mute);
									data.mute =true;
									scope.factory.printTrace(data.mute);
								}
							}
						});
					}

					scope.isDropMenu = function(data){
						if(!angular.isDefined(data.isDrop)){
							data.isDrop = true;
						} else {
							data.isDrop = !data.isDrop;
						}
					}

					scope.isDropNumMenu = function(data){
						if(!angular.isDefined(data.isNumDrop)){
							data.isNumDrop = true;
						} else {
							data.isNumDrop = !data.isNumDrop;
						}
					}

					scope.isDropNumSelect = function(data){
						if(!angular.isDefined(data.isNumSelect)){
							data.isNumSelect = true;
						} else {
							data.isNumSelect = !data.isNumSelect;
						}
					}
					
					scope.inviteBtn = function(data){
						if(!BOOL_USE_INTERFACE)
						{
							if(data.selectedtype == "MD1-userCard type_5"){
								data.callStatus = 1;
								data.selectedtype = "MD1-userCard type_2";
							}
						}
						else{
							scope.factory.removeMember(data).then(function(item){
								if(item != false){
									scope.factory.broadcastUIEvent("OUT_GROUP_CALL_MEMBER",item);
								}
							});
						}
					}
					scope.outBtn = function(data){  // invite
						if(!BOOL_USE_INTERFACE) {
							if (data.selectedtype == "MD1-userCard type_2"){
								data.callStatus = 0;
								data.selectedtype = "MD1-userCard type_5";
							}
						}
						else{
							scope.factory.reinviteToGroupCall(data);
						}
					}
					
					scope.closeMenu = function(parent, data){
						parent.isDrop = false;
						parent.selectedPhone = data;
					}

					scope.closeSelectMenu = function(parent, data){
						parent.isNumSelect = false;
						parent.selectedPhone = data;
					}
					scope.isStation = true;
					scope.closeNumMenu = function(parent, data){
						parent.isNumDrop = false;
						scope.numtype = data;
						if(scope.numtype == scope.factory.global.Station){
							parent.isStation = true;
							scope.isStation = true;
						}
						else if(scope.numtype == scope.factory.global.CO){
							parent.isStation = false;
							scope.isStation = false;
						}
					}

					scope.SaveNumber = function(data){
						//console.log("addednumber");
						//console.log(scope.newnumber);
						data.phoneArr.push(scope.newnumber);
						scope.newnumber = "";

					}
					
					scope.createPhoneData = function(data){
						////console.log("createPhoneData//////////////////////////////////////////////");
						////console.log(data);
						data.phoneArr = [];
						data.selectedPhone;
						var currentNum = angular.isDefined(scope.factory.currentCallNumber) ? scope.factory.currentCallNumber : -1;
						
						if(angular.isDefined(data.str_desk_phone1) && data.str_desk_phone1.val != "" && data.str_desk_phone1.val != null && angular.isDefined(data.str_desk_phone1.val)){
							data.phoneArr.push(data.str_desk_phone1.val);
							if(data.str_desk_phone1.val == currentNum){
								data.selectedPhone = currentNum;
								scope.factory.currentCallNumber = undefined;
							}
						}
						if(angular.isDefined(data.str_cellular_phone) && data.str_cellular_phone.val != "" && data.str_cellular_phone.val != null && angular.isDefined(data.str_cellular_phone.val)){
							data.phoneArr.push(data.str_cellular_phone.val);
							if(data.str_cellular_phone.val == currentNum){
								data.selectedPhone = currentNum;
								scope.factory.currentCallNumber = undefined;
							}
						}
						if(angular.isDefined(data.str_home_telephone) && data.str_home_telephone.val != "" && data.str_home_telephone.val != null && angular.isDefined(data.str_home_telephone.val)){
							data.phoneArr.push(data.str_home_telephone.val);
							if(data.str_home_telephone.val == currentNum){
								data.selectedPhone = currentNum;
								scope.factory.currentCallNumber = undefined;
							}
						}
						if(angular.isDefined(data.str_office_telephone) && data.str_office_telephone.val != "" && data.str_office_telephone.val != null && angular.isDefined(data.str_office_telephone.val)){
							data.phoneArr.push(data.str_office_telephone.val);
							if(data.str_office_telephone.val == currentNum){
								data.selectedPhone = currentNum;
								scope.factory.currentCallNumber = undefined;
							}
						}

						/*if(!angular.isDefined(data.selectedPhone)){
							data.selectedPhone = data.str_user_number.val;
						}*/

						if(BOOL_USE_INTERFACE)
						{
							if(!angular.isDefined(data.selectedPhone)){
								data.selectedPhone = data.str_user_number.val;
							}

							if(data.str_user_key.val != undefined)
							{
								//console.log("phonedata");
								//console.log(data);
								if(data.str_office_telephone.val !="" && data.str_office_telephone.val != undefined)
								{
									if(typeof data.str_user_key.val === 'string'){
										if(data.str_user_key.val.startsWith("p") == true ){
											data.selectedPhone = data.str_office_telephone.val;
										}

									}


								}

							}
						}


						data.selectedtype = (data.str_user_key.val == "dummy" ? "MD1-userCard type_10" : "MD1-userCard type_11") 
						
						if(data.str_user_key.val != "dummy" && data.str_user_key.val != "add"){
							
							data.selectedtype = selectTypeFunc(data.int_ui_type);
						}
					}
					
					function selectTypeFunc(no){
						var result;
						switch(no){
							case 1 :
								result = "MD1-userCard type_1";
								break;
							case 2 :
								result = "MD1-userCard type_2";
								break;
							case 3 :
								result = "MD1-userCard type_3";
								break;
							case 4 :
								result = "MD1-userCard type_4";
								break;
							case 5 :
								result = "MD1-userCard type_5";
								break;
							case 6 :
								result = "MD1-userCard type_6";
								break;
							case 7 :
								result = "MD1-userCard type_7";
								break;
							case 8 :
								result = "MD1-userCard type_8";
								break;
							case 9 :
								result = "MD1-userCard type_9";
								break;
							case 10 :
								result = "MD1-userCard type_10";
								break;
							case 11 :
								result = "MD1-userCard type_11";
								break;
							case 12 :
								result = "MD1-userCard type_12";
								break;
							case 13 :
								result = "MD1-userCard type_13";
								break;
							case 14 :
								result = "MD1-userCard type_14";
								break;
						}
						return result;
					}
					scope.numberType = function(){
						//console.log("numtype1111111111111");
						scope.numtype =scope.factory.global.Station;
						scope.numDropDown = [];
						scope.numDropDown.push(scope.factory.global.Station);
						scope.numDropDown.push(scope.factory.global.CO);
					}
					scope.numberType();
					scope.createPhoneData(scope.data);
			}
		}
	})
	//trans
	amoebaModule.directive("amContentTransList", function(){
		return {
			template :
			'<div class="MD1-userCard type_12" ng-click="selectTrans(tData)">'+
				'<div class="MD1-topZone">'+
					'<div class="MD1-xBox">'+
						'<button><i></i></button>'+
					'</div>'+
					'<div class="MD1-soundBox">'+
						'<label class="MD1-chk"><input type="checkbox" name="MD1-chk"><i class="soundIcon"></i></label>'+
					'</div>'+
				'</div>'+
				'<div class="MD1-middleZone">'+
					'<div class="MD1-checkBox">'+
						'<label class="MD1-chk"><input type="checkbox" name="MD1-chk"><i ng-class="icon"></i></label>'+
					'</div>'+
					'<div class="MD1-photoBox">'+
						'<img ng-src="{{service.currentPic(tData)}}" alt="사진">'+
						'<em class="nth_1" ng-class="onlybgClass" ng-show="tData.check==true"></em>'+
						'<em class="nth_2"></em>'+
					'</div>'+
					//'<div class="MD1-stateBox">'+
					//	'<i ng-class="service.getImStatusIcon(tData.str_im_status.val)"  ng-hide ="tData.int_user_type.val != 1"></i>'+
					//'</div>'+
				'</div>'+
				'<div class="MD1-bottomZone">'+
					'<div class="MD1-name1Box">'+
						'<p>{{tData.str_first_name.val}}</p>'+
					'</div>'+
					'<div class="MD1-num1Box" ng-click="MD1_userCard=!MD1_userCard" ng-class="{\'on\':MD1_userCard==true}">'+
						'<div class="MD1-numBox_inw">'+
							'<i ng-class = "service.getPhoneStatusIcon(tData.str_phone_status.val)"  ng-hide="tData.int_user_type.val == 3"></i>'+
						'<p>{{tData.str_desk_phone1.val}}</p><i class="MD1-num1_i" ng-class="{\'icon-caret-up\':MD1_userCard==true,\'icon-caret-down\':MD1_userCard==false}" ng-init="MD1_userCard=false"></i>'+
						//'<p data-text="{{factory.global.lang_no_info}}">{{tData.str_desk_phone1.val}}</p><i class="MD1-num1_i" ng-class="{\'icon-caret-up\':MD1_userCard==true,\'icon-caret-down\':MD1_userCard==false}" ng-init="MD1_userCard=false"></i>'+
						'</div>'+
					'</div>'+
				'</div>'+
				'<div class="MD1-backgroundZone bd_blue">'+
					'<div class="MD1-UIH">'+
						'<span>User Images <br/>Here</span>'+
					'</div>'+
					'<div class="MD1-STS">'+
						'<button><i></i></button>'+
						'<span>Select the button<br/>to switch to a multi<br/>selection mode.</span>'+
					'</div>'+
				'</div>'+
			'</div>',

				replace: true,
				restrict: 'A',
				link: function(scope, element){
			}
		}
	})
		amoebaModule.directive("amContentTransResult", function(){
		return {
			//uData.str_phone_status.val
			template :
			'<div class="MD1-userCard type_3">'+
				'<div class="MD1-topZone">'+
					'<div class="MD1-xBox">'+
						'<button ng-click="resetResult()"><i></i></button>'+
					'</div>'+
					'<div class="MD1-soundBox">'+
						'<label class="MD1-chk"><input type="checkbox" name="MD1-chk"><i class="soundIcon"></i></label>'+
					'</div>'+
				'</div>'+
				'<div class="MD1-middleZone">'+
					'<div class="MD1-checkBox">'+
						'<label class="MD1-chk"><input type="checkbox" name="MD1-chk"><i ng-class="icon"></i></label>'+
					'</div>'+
					'<div class="MD1-photoBox">'+
						'<img ng-src="{{service.currentPic(rData)}}" alt="사진">'+
						'<em class="nth_1" ng-class="onlybgClass"></em>'+
						'<em class="nth_2"></em>'+
					'</div>'+
					//'<div class="MD1-stateBox">'+
					//	'<i ng-class="service.getImStatusIcon(rData.str_im_status.val)" ng-hide ="rData.int_user_type.val != 1"></i>'+
					//'</div>'+
				'</div>'+
				'<div class="MD1-bottomZone">'+
					'<div class="MD1-name1Box">'+
						'<p>{{rData.str_first_name.val}}</p>'+
					'</div>'+
					'<div class="MD1-num1Box" ng-click="MD1_userCard=!MD1_userCard" ng-class="{\'on\':MD1_userCard==true}">'+
						'<div class="MD1-numBox_inw">'+
							'<i ng-class = "service.getPhoneStatusIcon(rData.str_phone_status.val)" ng-hide ="rData.int_user_type.val ==3"></i>'+
							//'<p>{{rData.is_selected}}</p><i class="MD1-num1_i" ng-class="{\'icon-caret-up\':MD1_userCard==true,\'icon-caret-down\':MD1_userCard==false}" ng-init="MD1_userCard=false"></i>'+
				// changwon edit 0315 p태그에 data-text부분 추가
							'<p>{{rData.is_selected}}</p><i class="MD1-num1_i" ng-class="{\'icon-caret-up\':MD1_userCard==true,\'icon-caret-down\':MD1_userCard==false}" ng-init="MD1_userCard=false"></i>'+
						'</div>'+
					'</div>'+
					'<div class="MD1-num2Box">'+
								// changwon edit 0315 p태그에 data-text부분 추가
							'<p class="MD1-dropList" ng-click="rData.is_selected = rData.str_desk_phone1.val;MD1_userCard=false" ng-hide="rData.str_desk_phone1.val == \'\' || rData.str_desk_phone1.val == null ">{{rData.str_desk_phone1.val}}</p>'+
								// changwon edit 0315 p태그에 data-text부분 추가
							'<p  class="MD1-dropList" ng-click="rData.is_selected = rData.str_cellular_phone.val;MD1_userCard=false" ng-hide="rData.str_cellular_phone.val == \'\' || rData.str_cellular_phone.val == null">{{rData.str_cellular_phone.val}}</p>'+
								// changwon edit 0315 p태그에 data-text부분 추가
							'<p  class="MD1-dropList" ng-click="rData.is_selected = rData.str_office_telephone.val;MD1_userCard=false" ng-hide="rData.str_office_telephone.val == \'\' || rData.str_office_telephone.val == null">{{rData.str_office_telephone.val}}</p>'+
								// changwon edit 0315 p태그에 data-text부분 추가
							'<p class="MD1-dropList" ng-click="rData.is_selected = rData.str_home_telephone.val;MD1_userCard=false" ng-hide="rData.str_home_telephone.val == \'\' || rData.str_home_telephone.val == null" >{{rData.str_home_telephone.val}}</p>'+
				/*
							'<p class="MD1-dropList" ng-click="rData.is_selected = rData.str_desk_phone1.val;MD1_userCard=false">{{rData.str_desk_phone1.val}}</p>'+
							'<p class="MD1-dropList" ng-click="rData.is_selected = rData.str_cellular_phone.val;MD1_userCard=false">{{rData.str_cellular_phone.val}}</p>'+
							'<p class="MD1-dropList" ng-click="rData.is_selected = rData.str_office_telephone.val;MD1_userCard=false">{{rData.str_office_telephone.val}}</p>'+
							'<p class="MD1-dropList" ng-click="rData.is_selected = rData.str_home_telephone.val;MD1_userCard=false">{{rData.str_home_telephone.val}}</p>'+
							*/
						'</div>'+
						'<div class="MD1-name2Box">'+
						'<p>{{}}{{}}</p>'+
						'</div>'+
						'<div class="MD1-btnBox">'+
						'<button class="MD1-btn1">{{factory.global.lang_out}}</button>'+
						'<button class="MD1-btn2">{{factory.global.lang_invite}}</button>'+
						'</div>'+
						'</div>'+
						'<div class="MD1-backgroundZone bd_blue">'+
						'<div class="MD1-UIH">'+
						'<span>{{factory.global.lang_user_images_here}}</span>'+
						'</div>'+
						'<div class="MD1-MSM1">'+
						'<button><i></i></button>'+
						'<span>{{factory.global.lang_multi_select_mode1}}</span>'+
						'</div>'+
						'<div class="MD1-MSM2">'+
						'<button><i></i></button>'+
						'<span>{{factory.global.lang_multi_select_mode2}}</span>'+
						'</div>'+
						'</div>'+
						'</div>',



						restrict: 'A',
						link: function(scope, element){
						}
					}
	})
	//content Missed Call
	amoebaModule.directive('amContentMissedCallResult', function(){
		return {
			template :
					'<td></td>'+
					'<td class="time">'+
						'{{currentTime(mData.str_conv_log_datetime.val)}}'+
					'</td>'+
					
//					'<td class="userInfo">'+
//						'<div class="photo_wrap">'+
//							'<div class="photo"><img ng-src="{{setPic(mData)}}" alt="photo"></div>'+
//							'<i ng-class="service.getImStatusIcon(mData.str_im_status.val)"></i>'+
//							'<i ng-class = "{\'0\' : \'icon_state state1\', \'1\' : \'icon_state state2\', \'2\' : \'icon_state state3\', \'3\' : \'icon_state state4\', \'4\' : \'icon_state state5\'}[mData.str_phone_status.val]"></i>'+
//						'</div>'+
//						'<p title="{{mData.str_conv_name.val}}">{{mData.str_conv_name.val}}</p>'+
//					'</td>'+
					
					
					'<td class="userInfo">'+
						'<div class="photo_wrap" ng-init="service.isConvPhoto(mData)">'+
							'<div ng-class="{1 : \'photo ea1\', 2 : \'photo ea2\', 3 : \'photo ea3\', 4 : \'photo ea4\'}[mData.photos]">'+
								'<span am-photo-list ng-repeat="pData in mData.picture_list"></span>'+
							'</div>'+
						'</div>'+
						'<p>{{mData.str_conv_name.val}}</p>'+
					'</td>'+					
					
					
					'<td class="content">'+
						'<p>{{mData.str_desk_phone1.val}}</p>'+
					'</td>'+
					'<td class="count"><span ng-hide="mData.int_plus_Count.val == 0">( {{mData.int_plus_Count.val}} ) </span></td>'+
					'<td class="btn">'+
						'<button ng-click="moveToGroup(mData)">{{factory.global.lang_im}}</button>'+
						'<button ng-click="goToCall(mData)">{{factory.global.lang_call}}</button>'+
					'</td>'+
					'<td></td>',
			restrict : 'A'
// 			link : function(scope, element){
//
// 				var $list = $('#missed_call_list tbody > tr, #voice_mail_list tbody > tr, #new_im_list tbody > tr');
// //		        var selectDialogChk = $list.parent().hasClass('im_dialogs_selectable');
//
//
// 		        $list.mouseenter(function () {
// 		                $(this).toggleClass('iuhover');
// 		            })
// 		            .mouseleave(function () {
// 		                $(this).removeClass('iuhover');
// 		            });
//
// 			}

		}
	});

	//content Voice Mail
	amoebaModule.directive('amContentVoiceMailResult', function(){
		return {
			template :
							'<td ng-init="service.setVoiceDefault(mData)"></td>'+
							'<td class="time">'+
								'{{currentTime(mData.str_conv_log_datetime.val)}}'+
							'</td>'+
							'<td class="userInfo">'+
								'<div class="photo_wrap">'+
									'<div class="photo"><img ng-src="{{setPic(mData)}}" alt="photo"></div>'+
								//	'<i ng-class="service.getImStatusIcon(mData.str_im_status.val)"></i>'+
								//	'<i ng-class = "{\'0\' : \'icon_state state1\', \'1\' : \'icon_state state2\', \'2\' : \'icon_state state3\', \'3\' : \'icon_state state4\', \'4\' : \'icon_state state5\'}[mData.str_phone_status.val]"></i>'+
								'</div>'+
								'<p>{{mData.str_conv_name.val}}</p>'+
							'</td>'+
							'<td class="content">'+
								'<p>{{mData.str_file_name.val}}</p>'+
								'<div class="horizonGauge_wrap">'+
									'<div class="horizonGauge_void">'+
										'<div class="horizonGauge_solid" ng-style="mData.width"></div>'+
									'</div>'+
									'<p>'+
									'<span class="play_time1">{{mData.play_time}}</span>'+
									'<span class="play_time2">{{mData.str_conv_log_duration.val}}</span>'+
									'</p>'+
								'</div>'+
							'</td>'+
							'<td class="play_wrap">'+
								//'<button class="play" ng-if="mData.isVoicemail_play == false" ng-click="service.playVoice(mData)"><i></i></button>'+
								//'<button class="play" ng-if="mData.isVoicemail_play == false" ng-click="service.voiceMailStart(mData)"><i></i></button>'+
								'<button class="play" ng-click="service.voiceMailStart(mData)"><i></i></button>'+
								//'<button class="pause" ng-if="mData.isVoicemail_play == true" ng-click="service.stopVoice(mData)"><i></i></button>'+
							'</td>'+
							'<td class="count"><span ng-hide="mData.int_plus_Count.val == 0">( {{mData.int_plus_Count.val}} ) </span></td>'+
							'<td class="btn">'+
								//'<button class="dim">{{factory.global.lang_im}}</button>'+
								//'<button class="dim">{{factory.global.lang_call}}</button>'+
								'<button ng-click="moveToGroup(mData)">{{factory.global.lang_im}}</button>'+
								'<button ng-click="goToCall(mData)">{{factory.global.lang_call}}</button>'+
							'</td>'+
							'<td></td>',
					// standard
					// <td class="content">
					// 	<p>Meeting</p>
					// </td>
					// <td class="btn">
					// 	<!-- 버튼은 둘 중 하나만 나타나야함 -->
					// 	<button style="width:16rem;">Server Disconnect</button>
					// 	<button style="width:16rem;">Server Connect</button>
					// </td>
			restrict : 'A',
			link : function(scope, element){}

		}
	});

	//content New I.M
	amoebaModule.directive('amContentImResult', function(){
		return {
			template :
					'<td></td>'+
					'<td class="time">'+
						'{{currentTime(mData.str_conv_log_datetime.val)}}'+
					'</td>'+
//					'<td class="userInfo">'+
//						'<div class="photo_wrap">'+
//							'<div class="photo"><img ng-src="{{setPic(mData)}}" alt="photo"></div>'+
//							'<i ng-class="service.getImStatusIcon(mData.str_im_status.val)"></i>'+
//							'<i ng-class = "{\'0\' : \'icon_state state1\', \'1\' : \'icon_state state2\', \'2\' : \'icon_state state3\', \'3\' : \'icon_state state4\', \'4\' : \'icon_state state5\'}[mData.str_phone_status.val]"></i>'+
//						'</div>'+
//						'<p>{{mData.str_conv_name.val}}</p>'+
//					'</td>'+
					
					'<td class="userInfo">'+
						'<div class="photo_wrap" ng-init="service.isConvPhoto(mData)">'+
							'<div ng-class="{1 : \'photo ea1\', 2 : \'photo ea2\', 3 : \'photo ea3\', 4 : \'photo ea4\'}[mData.photos]">'+
								'<span am-photo-list ng-repeat="pData in mData.picture_list"></span>'+
							'</div>'+
						'</div>'+
						'<p>{{mData.str_conv_name.val}}</p>'+
					'</td>'+
					
					
					'<td class="content">'+
//					1. call 2. missed call, 3. im 4, sms, 5. note 6. adminmsg 7.voicemail 8. picture 9. file
						'<p><i ng-class="{3 : \'im\', 4 : \'sms\', 5 : \'im\', 8 : \'pic\', 9 : \'clip\'}[mData.int_conv_log_type.val]"></i>{{mData.str_conv_log_content.val}}</p>'+
					'</td>'+
					'<td class="count"><span ng-hide="mData.int_plus_Count.val == 0">( {{mData.int_plus_Count.val}} ) </span></td>'+
					'<td class="btn">'+
						'<button ng-click="moveToGroup(mData)">{{factory.global.lang_im}}</button>'+
						'<button ng-click="goToCall(mData)">{{factory.global.lang_call}}</button>'+
					'</td>'+
					'<td></td>',
			restrict : 'A',
			link : function(scope, element){}

		}
	});
// sms클래스 위치에 sms일 경우 sms
// file 일 경우 file
// im일경우 im
// picture 일 경우 picture




//	amoebaModule.directive('amPhoneNumberList', function(){
//		return {
//				template :
//					<!-- <ul class="numList" ng-class="{'down':isNumlist==5}"> -->
//						<li class="call" ng-click="isNumlist=false">
//							'<span><i ng-class = "{0 : \'icon_state state1\', 1 : \'icon_state state2\', 2 : \'icon_state state3\', 3 : \'icon-phone orange\'}[uData.str_phone_status.val]"></i>'+
//							'</span>'+
//							<span><i class="icon-phone orange"></i>
//							5678</span><i class="icon-caret-up"></i></li>
//						<li><span>3481</span></li>
//						<li><span>02-5166-5163</span></li>
//						<li><span>010-5126-5688</span></li>
//						<li ng-click="isNumlist=5"><i class="icon-caret-down"></i></li>
//					</ul>
//		}
//	}),

	amoebaModule.directive('amRecentPhotoList' , function(){
		return {
			template :
				'<img ng-src="{{pData.val}}" alt="photo">',
			restrict: 'A',
			link: function(scope, element){
			}
		}
	})

	amoebaModule.directive('amContentRecentActivityList', function(){

		return {
			template:
				'<table>'+
					'<tbody ng-init="isPhoto(recentData)">'+
						'<tr ng-class="{0 : \'incall\', 1 : \'outcall\', 2 : \'missed\', 3 : \'im\', 4 : \'sms\', 5 : \'im\', 6 : \'notice\', 7 : \'voicemail\', 8 : \'image\', 9 : \'file\', 10 : \'im\', 11: \'callback\'}[recentData.conv_status.val]">'+
							'<td class="icon"><i></i></td>'+
							'<td class="cont">'+
								'<p>'+
									//'<span class="cont1">{{recentData.str_conv_name.val}}</span><br/>'+
									'<span class="cont1">{{service.getRecentActivityName(recentData)}}</span><br/>'+
									'<span class="cont2">{{service.getMeText(recentData)}}{{recentData.str_conv_log_content.val}}</span>'+
								'</p>'+
							'</td>'+
							'<td class="count">'+
								'<span ng-hide="recentData.int_plus_Count == 0">({{recentData.int_plus_Count}})</span>'+
							'</td>'+
							'<td class="time">{{currentTime(recentData.str_conv_log_datetime.val)}}</td>'+
							'<td class="date">{{currentDate(recentData.str_conv_log_datetime.val)}}</td>'+
							'<td class="userInfo">'+
								'<div class="photo_wrap">'+
									'<div ng-class="{1 : \'photo ea1\', 2 : \'photo ea2\', 3 : \'photo ea3\', 4 : \'photo ea4\'}[recentData.photos]" >'+
										'<span am-photo-list ng-repeat="pData in recentData.picture_list"></span>'+
									'</div>'+
								'</div>'+
							'</td>'+
						'</tr>'+
					'</tbody>'+
				'</table>',
			restrict: 'A',
			link: function(scope, element){

			}
		//ng-show="recentData.photos != 1 && recentData.photos != 2"
		}
	});
	amoebaModule.directive('amDropDownList', function(){
		return {
			template : '{{recentDrop}}',
			restrict : 'A',
			replace: false,
			link : function(scope, element){

			}
		}
	});
	
	amoebaModule.directive('amDropBoxList', function() {
				return {
				template : '{{selectgData.name}}',//'<li ng-click="selectGroup(selectgData)">{{selectgData.name}}</li>',
				restrict: 'A',
				link: function(scope, element){

			}
		}
	})

	// Setting Notification Ring List
	amoebaModule.directive('amRingList', function() {
				return {
				template : '{{ring.str_ring_name}}',
				restrict: 'A',
				link: function(scope, element){

			}
		}
	});

	// Setting Notification Ring List
	amoebaModule.directive('amSpeakerList', function() {
		return {
			template : '{{data.str_speaker_name}}',
			restrict: 'A',
			link: function(scope, element){

			}
		}
	});

	// Setting Call Option Advanced Prefix digit(s)
	amoebaModule.directive('amDigitsList', function() {
		return {
			template : '<p>{{data}}</p><button ng-click="deleteDigits(data)"><em>삭제</em></button>',
			restrict: 'A',
			link: function(scope, element){

			}
		}
	});

	// Login Setting Server Address
	amoebaModule.directive('amMultiloginList', function() {
		return {
			template : '{{data.str_user_id.val}}',
			restrict: 'A',
			link: function(scope, element){

			}
		}
	});

	// Login Language
	amoebaModule.directive('amLangList', function() {
		return {
			template : '{{data.displayname}}', // 0222 hyosung
			restrict: 'A',
			link: function(scope, element){

			}
		}
	});

	// 우측 다이얼 키패드탭의 번호 검색
	amoebaModule.directive('amKeypadSearch', function() {
		return {
			template : '<div class="photo" ng-class="{\'on\':data.check==true}"><span><img ng-src="{{data.str_picture_data.val}}" alt="사진"></span></div>'
				//+ '<i ng-class="service.getImStatusIcon(data.str_im_status.val)" ng-hide="!service.checkIMUser(data)"></i>'
			+ '<i ng-class="service.getImStatusIcon(data.str_im_status.val)" ng-hide="true"></i>'
				+ '<dl><dt>{{data.str_first_name.val}}</dt>'
				//+ '<dd><span class="call" ng-if="service.checkPrivate(data.str_user_key.val) == false"><i class ="icon_state state2" ng-hide="service.checkPhoneUser(data)"></i></span>'
			+ '<dd>'
				+ '<p><span>{{data.str_user_number.val}}</span></p></dd></dl>',
			restrict: 'A',
			link: function(scope, element){

			}
		}
	});

	//Call Memo
	amoebaModule.directive('amCallMemoList', function(){
		return {
			template :
					'<div ng-init="changeId(mData)" class="memo" ng-class = "mData.bool_is_edit.val == true ? currentBdClass : currentClass">'+
					//'<textarea id="memo" ng-model="mData.str_memo_textarea" ng-keydown="resize($event, mData)" ng-readonly="!mData.bool_is_edit.val" maxlength="200"></textarea>'+ 
					'<textarea id="memo" ng-model="mData.str_memo_textarea" ng-readonly="!mData.bool_is_edit.val" maxlength={{factory.memoMaxLength}}></textarea>'+
					'<div>'+
							'<em class="nth_1">'+
								'<span>{{factory.global.lang_max}} </span><span>200</span>'+
							'</em>'+
							'<em class="nth_2">'+
								'<span>{{service.setMemoTime(mData.str_memo_date.val)}}</span>'+
							'</em>'+
						'</div>'+
						'<button class="nth_x" ng-click="deleteMemo(mData)"><i class="times"></i></button>'+
						'<button class="nth_1" ng-class="currentClass == \'bg_blue\' ? \'text_blue\' : \'text_green\'" ng-click="addMemo(mData)">{{mData.btn}}</button>'+
						'<button class="nth_2"><i class="icon-pencil" ng-click="editMemo(mData)"></i></button>'+
					'</div>',
				restrict: 'A',
				replace: true,
				link: function(scope, element, attrs){
					//var target = scope.callData;
					//var html = scope.changeEmoticon(scope.callData.str_conv_log_content.val);
					//var html = scope.callData.str_conv_log_content.val;
					//html = scope.service.encodeHTML(html);
					
					var html = scope.mData.str_memo_date.val;
					html = html.replace(/\n/g, '<br>');
					element.find(".memo").html(html);
				}
		}
	});

	// My Profile 부서 목록 생성
	amoebaModule.directive('amMyprofileDeptlist', function() {
		return {
			template : '{{data.name}}',
			restrict: 'A',
			link: function(scope, element){

			}
		}
	});

	// Login Setting Server Address
	amoebaModule.directive('amMyprofilePositionlist', function() {
		return {
			template : '{{data.name}}',
			restrict: 'A',
			link: function(scope, element){

			}
		}
	});
	
	// Login Setting Server Address
	amoebaModule.directive('amTest', function() {
		return {
			template : '{{data.str_first_name.val}}',
			restrict: 'A',
			link: function(scope, element){

			}
		}
	});
	
	

	// call setting list
	amoebaModule.directive('amMyProfileNumList', function() {
		return {
			template : '{{nData}}',
			restrict: 'A',
			link: function(scope, element){

			}
		}
	});

	//forward result
	amoebaModule.directive("amForwardSearchResult", function(){ // 0201 hyosung // {{service.currentPic(data)}}, , {{data.str_position_name.val}}
		return {
			template :
				'<div class="innerwrap" ng-init="setForwardData(data)">'+
				'<div class="photo"><span ><img ng-src="{{data.str_picture_data.val}}" alt="photo" /></span></div>'+
				'<div class="textwrap">'+
				'<p class="txt1" title = "{{data.str_first_name.val}}">{{data.str_first_name.val}}</p>'+
				'<p class="txt2" title = "{{data.str_office_department.val}}">{{data.str_office_department.val}}</p>'+
				'</div>'+
				'</div>'+
				'<ul class="subMenu_wrap subMenu_wrap5" ng-class="{\'onlyData\': data.strary_num_list.length <= 1}">'+
				'<li class="slt" ng-click="openNumber()" ng-class="{\'on\':callNum==true}">'+
				'{{data.str_user_number.val}}'+
				'<i ng-class="{\'icon-angle-down\':callNum==false,\'icon-angle-up\':callNum==true}" class="style-flr icon-angle-down" ng-hide="data.strary_num_list.length <= 1"></i>'+
				'</li>'+
				'<li>'+
				'<ul class="subMenu" ng-class="{\'on\':callNum==true}">'+
				'<li class="opt" am-my-Profile-num-list ng-repeat="nData in data.strary_num_list" ng-click="selectedNum(data, nData)"></li>'+
				'</ul>'+
				'</li>'+
				'</ul>',
				restrict: 'A',
				link: function(scope, element, attrs){
				}
		}
	});
	
	//forward search
	amoebaModule.directive("amForwardSearchList", function(){ // 0201 hyosung // {{service.currentPic(data)}}, , {{data.str_position_name.val}}
		return {
			template :
				'<div class="innerwrap" ng-init="setForwardData(data)">'+
					'<div class="photo"><span ><img ng-src="{{data.str_picture_data.val}}" alt="photo" /></span></div>'+
					'<div class="textwrap">'+
						'<p class="txt1" title = "{{data.str_first_name.val}}">{{data.str_first_name.val}}</p>'+
						'<p class="txt2" title = "{{data.str_office_department.val}}">{{data.str_office_department.val}}</p>'+
					'</div>'+
				'</div>'+
				'<ul class="subMenu_wrap subMenu_wrap5">'+
					'<li class="slt">'+
					'{{data.str_user_number.val}}'+
					'</li>'+
				'</ul>',
				restrict: 'A',
				link: function(scope, element, attrs){
				}
		}
	});

	// 조직도 1Depth부터 6Depth까지
	amoebaModule.directive('amOrgList1', function() {
		return {
			template :
				'<button ng-click="selectOrgDepth(data1)"'
				+ 'data-key="{{data1.str_department_key.val}}"'
				+ 'data-name="{{data1.str_office_department.val}}"'
				+ 'data-order="{{data1.str_department_order.val}}"'
				+ 'data-parent="{{data1.str_parent_key.val}}"'
				+'>'
				+ '<i class="icon1"></i><i class="icon2"></i>'
				+ '{{data1.str_office_department.val}}</button>'
				+'<div am-org-list2 ng-repeat="data2 in organization" ng-if="data1.str_department_key.val == data2.str_parent_key.val" class="closed"></div>'
			, transclude : true
			, link: function(scope, element, attr){
				var el = element.find(".icon1");
				el.bind("click", function($event){
					$event.stopPropagation();
					var parent = el.parent().parent();
					parent.hasClass("closed") ? parent.removeClass("closed").addClass("open") : parent.removeClass("open").addClass("closed");
					el.hasClass("on") ? el.removeClass("on") : el.addClass("on");
					
					scope.orgUserIndex = 1;			
					scope.orgUserDpet = null;
				});
			},

		}
	});
	
	amoebaModule.directive('amOrgList2', function() {
		return {
			template :
				'<button ng-click="selectOrgDepth(data2)"'
				+ 'data-key="{{data2.str_department_key.val}}"'
				+ 'data-name="{{data2.str_office_department.val}}"'
				+ 'data-order="{{data2.str_department_order.val}}"'
				+ 'data-parent="{{data2.str_parent_key.val}}"'
				+'>'
				+'<i class="icon1"></i><i class="icon2"></i>{{data2.str_office_department.val}}</button>'
				+'<div am-org-list3 ng-repeat="data3 in organization" ng-if="data2.str_department_key.val == data3.str_parent_key.val" class="closed"></div>'
			, restrict: 'A'
			, transclude : true
			, link: function(scope, element, attr){
				var el = element.find(".icon1");
				el.bind("click", function($event){
					$event.stopPropagation();
					var parent = el.parent().parent();
					parent.hasClass("closed") ? parent.removeClass("closed").addClass("open") : parent.removeClass("open").addClass("closed");
					el.hasClass("on") ? el.removeClass("on") : el.addClass("on");
					
					scope.orgUserIndex = 1;			
					scope.orgUserDpet = null;
				});
			}
		}
	});
	
	amoebaModule.directive('amOrgList3', function() {
		return {
			template :
				'<button ng-click="selectOrgDepth(data3)"'
				+ 'data-key="{{data3.str_department_key.val}}"'
				+ 'data-name="{{data3.str_office_department.val}}"'
				+ 'data-order="{{data3.str_department_order.val}}"'
				+ 'data-parent="{{data3.str_parent_key.val}}"'
				+'>'
				+'<i class="icon1" class="on" ></i><i class="icon2"></i>{{data3.str_office_department.val}}</button>'
				+'<div am-org-list4 ng-repeat="data4 in organization" ng-if="data3.str_department_key.val == data4.str_parent_key.val" class="closed"></div>'
			, restrict: 'A'
			, transclude : true
			, link: function(scope, element, attr){
				var el = element.find(".icon1");
				el.bind("click", function($event){
					$event.stopPropagation();
					var parent = el.parent().parent();
					parent.hasClass("closed") ? parent.removeClass("closed").addClass("open") : parent.removeClass("open").addClass("closed");
					el.hasClass("on") ? el.removeClass("on") : el.addClass("on");
					
					scope.orgUserIndex = 1;			
					scope.orgUserDpet = null;
				});
			}
		}
	});
	
	amoebaModule.directive('amOrgList4', function() {
		return {
			template :
				'<button ng-click="selectOrgDepth(data4)"'
				+ 'data-key="{{data4.str_department_key.val}}"'
				+ 'data-name="{{data4.str_office_department.val}}"'
				+ 'data-order="{{data4.str_department_order.val}}"'
				+ 'data-parent="{{data4.str_parent_key.val}}"'
				+'>'
				+'<i class="icon1" class="on"></i><i class="icon2"></i>{{data4.str_office_department.val}}</button>'
				+'<div am-org-list5 ng-repeat="data5 in organization" ng-if="data4.str_department_key.val == data5.str_parent_key.val" class="closed"></div>'
			, restrict: 'A'
			, transclude : true
			, link: function(scope, element, attr){
				var el = element.find(".icon1");
				el.bind("click", function($event){
					$event.stopPropagation();
					var parent = el.parent().parent();
					parent.hasClass("closed") ? parent.removeClass("closed").addClass("open") : parent.removeClass("open").addClass("closed");
					el.hasClass("on") ? el.removeClass("on") : el.addClass("on");
					
					scope.orgUserIndex = 1;			
					scope.orgUserDpet = null;
				});
			}
		}
	});
	
	amoebaModule.directive('amOrgList5', function() {
		return {
			template :
				'<button ng-click="selectOrgDepth(data5)"'
				+ 'data-key="{{data5.str_department_key.val}}"'
				+ 'data-name="{{data5.str_office_department.val}}"'
				+ 'data-order="{{data5.str_department_order.val}}"'
				+ 'data-parent="{{data5.str_parent_key.val}}"'
				+'>'
				+'<i class="icon1" class="on"></i><i class="icon2"></i>{{data5.str_office_department.val}}</button>'
				+'<div am-org-list6 ng-repeat="data6 in organization" ng-if="data5.str_department_key.val == data6.str_parent_key.val" class="closed"></div>'
			, restrict: 'A'
			, transclude : true
			, link: function(scope, element, attr){
				var el = element.find(".icon1");
				el.bind("click", function($event){
					$event.stopPropagation();
					var parent = el.parent().parent();
					parent.hasClass("closed") ? parent.removeClass("closed").addClass("open") : parent.removeClass("open").addClass("closed");
					el.hasClass("on") ? el.removeClass("on") : el.addClass("on");
					
					scope.orgUserIndex = 1;			
					scope.orgUserDpet = null;
				});
			}
		}
	});
	
	amoebaModule.directive('amOrgList6', function() {
		return {
			template :
				'<button ng-click="selectOrgDepth(data6)"'
				+ 'data-key="{{data6.str_department_key.val}}"'
				+ 'data-name="{{data6.str_office_department.val}}"'
				+ 'data-order="{{data6.str_department_order.val}}"'
				+ 'data-parent="{{data6.str_parent_key.val}}"'
				+'>'
				+ '<i class="icon1" class="on"></i><i class="icon2"></i>{{data6.str_office_department.val}}</button>'
				, restrict: 'A'
				, transclude : true
				, link: function(scope, element, attr){
					scope.orgUserIndex = 1;			
					scope.orgUserDpet = null;
				}
		}
	});
	
	amoebaModule.directive('amLoginHistoryList', function() {
		return {
			template :
				 '<dl>'+
	                '<dt>{{data.str_user_id.val}}</dt>'+
	                '<dd>{{data.str_server_ip.val}}<button class="nth_x" ng-click="deleteHistory(data.str_user_id.val, data.str_server_ip.val)"><i class="times"></i></button></dd>'+
	              '</dl>'
			, restrict: 'A'
			, link: function(scope, element){}
		}
	});
	
	amoebaModule.directive('amDestinationList', function() {
		return {
			template : '{{data.str_type_name}}',
			restrict: 'A',
			link: function(scope, element){

			}
		}
	});
	
	amoebaModule.directive('amForwardList', function() { // 0223 hyosung
		return {
//			template : '{{data.str_user_phone_number.val}}',
			template : '<a href="#">{{data.str_display_name_with_condition.val}}</a>',
			restrict: 'A',
			link: function(scope, element){
			}
		}
	});

	amoebaModule.directive('amFowardHistoryList', function() {
		return {
			template :
			'<dl>'+
			'<dt>{{data.str_display_name.val}}</dt>'+
			'<dd>{{service.getNumberTypeName(data.int_number_type.val)}}</dd>' +
			'<dd>{{service.getFowardTypeName(data.int_forward_type.val)}}<button class="nth_x" ng-click="deleteForwardHistory(data.int_forward_log_id.val)"><i class="times"></i></button></dd>'+
			'</dl>'
			, restrict: 'A'
			, link: function(scope, element){}
		}
	});

	amoebaModule.directive('isNumber', function () {
	    return {
	        require: 'ngModel',
	        link: function (scope) {    
	            scope.$watch('dial.number', function(newValue,oldValue) {
	                var arr = String(newValue).split("");
	                if (arr.length === 0) return;	                
	                if (isNaN(newValue)) {
	                    scope.dial.number = oldValue;
	                }
	            });
	        }
	    };
	})

	// Login Language
	amoebaModule.directive('amForwardtypeList', function() {
		return {
			template : '{{data.str_type_name}}',
			restrict: 'A',
			link: function(scope, element){
			}
		}
	});	
	
	// 조직도 선택 리스트
	amoebaModule.directive('amOrgDeptList', ["$timeout", function($timeout) {
		return {
			template :
				'<div class="group-title">'
				+ '<label class="contact-chk" ng-hide="allDeptCheck == false">'
				+ '<input type="checkbox" ng-model="data.check" ng-change="deptAllUserCheck(data)"/>'
				+ '<i ng-class="iconClass"></i>'
				+ '</label>'
				+ '<button class="state-btn">'
				+ '<div>'
				+ '<i class="icon-angle-down updown" ng-if="data.deptParent == null"></i>'
				+ '<p>{{data.deptName}}</p>'
				+ '<span class="group-num" ng-if="data.deptParent == null">({{data.deptUserSize}})</span>'
				+ '</div>'
				+ '</button>'
				+ '</div>'
        
				+ '<div class="group-list" ng-class="{\'type-large\':isPopupIcon==1, \'type-list\':isPopupIcon==3}">'
//				+ '<ul id="deptMemberList"><li ng-mouseover="overMember(uData)" ng-mouseout="outMember()" am-dept-user-list ng-repeat="uData in data.deptMember | orderBy: isOrderby"><li></ul>'
				+ '<ul id="deptMemberList"><li am-dept-user-list ng-repeat="uData in data.deptMember | orderBy: isOrderby" ng-hide="uData.str_im_status.val == \'0\' && viewAll == false && uData.int_user_type.val == 1"><li></ul>'
				+ '</div>'
			, restrict: 'A'
			, transclude : true
			, link: function(scope, element, attr){
				
				element.find(".state-btn").bind("click", function($event){

					$event.stopPropagation();
					element.hasClass("on") ? element.removeClass("on") :element.addClass("on");
					
					var updown = element.find('.updown');
					if(updown.hasClass("icon-angle-up")){
						updown.removeClass("icon-angle-up");
						updown.addClass("icon-angle-down");
					}
					else{
						updown.removeClass("icon-angle-down");
						updown.addClass("icon-angle-up");
					}
					
				});
				/*
				scope.outMember = function(){
			    	scope.factory.isDragEnd = false;
				}
				
				scope.overMember = function(data){
					scope.factory.dragData = data;
					scope.factory.isDragEnd = true;
				}
				*/
			}
		}
	}]);	
	
	// 선택된 조직의 그룹원 리스트
	amoebaModule.directive('amDeptUserList', function(){
		return {
			template :
				'<label class="dialog-chk" ng-class="{dim : uData.isDim == true || uData.str_user_key.val == factory.userInfoData.str_my_key}">'
				+ '<input type="checkbox" name="chk_info" ng-model="uData.check" ng-change="contactUserCheck(uData, false, false,false)"/>'
				+ '<i ng-class="iconClass"></i>'
				+ '</label>'
				+ '<div ng-click="currentProfileFun(uData)" class="photo"><span ><img ng-src="{{uData.str_picture_data.val}}" alt="photo" /></span></div>'
				+ '<i ng-click="currentProfileFun(uData)" ng-class ="service.getImStatusIcon(uData.str_im_status.val)" ng-hide ="!service.checkIMUser(uData)"></i>'
				+ '<dl ng-click="currentProfileFun(uData)">'
					// START designIssue1 changwon 수정사항 적용
				+ '<dt class="fwb">'
					// END designIssue1 changwon 수정사항 적용
				+ '<span class="call"><i ng-class = "service.getPhoneStatusIcon(uData.str_phone_status.val)" ng-hide="service.checkPhoneUser(uData)"></i></span>'
				+ '{{uData.str_first_name.val}}'
//				+ '{{uData.str_first_name.val}} / {{service.getImStatusIcon(uData.str_im_status.val)}} / {{uData.str_im_status.val}}'
				+'</dt>'
				+'<dd>'
				+ '<span>{{uData.str_position_name.val}}</span>'
				+ '</dd>'
				+ '<dd>'
				+ '<p>{{uData.str_today_user_message.val}}</p>'
				+ '</dd>'
				+ '</dl>'
			, restrict: 'A'
			, transclude : true
			, link: function(scope, element, attr){
				element.bind("click", function($event){
					$event.stopPropagation();
					
				});
//	 				var $list = $('#missed_call_list tbody > tr, #voice_mail_list tbody > tr, #new_im_list tbody > tr');
//	 		        $list.mouseenter(function () {
//	 		                $(this).toggleClass('iuhover');
//	 		            })
//	 		            .mouseleave(function () {
//	 		                $(this).removeClass('iuhover');
//	 		            });
			}
		}		
	});

	// SMS 날짜 리스트
	amoebaModule.directive('amSmsDateList', function(){
		return {
			template :
				'<h6>{{sDate}}</h6>'
				+ '<legend>{{sDate}}</legend>'
				+ '<table>'
				+ '<tbody><tr am-sms-list ng-repeat="data in smsData" ng-if="sDate == service.smsListTime(data.str_conv_datetime.val)"></tr></tbody>'
				+ '</table>'
			, restrict: 'A'
			, transclude : true
			, link: function(scope, element, attr){}
		}		
	});
	
	// SMS 리스트
	amoebaModule.directive('amSmsList', function(){
		return {
			template :
				'<td></td><td ng-init="isPhoto(data)">'
				+ '<div ng-class="{1 : \'photo ea1\', 2 : \'photo ea2\', 3 : \'photo ea3\', 4 : \'photo ea4\'}[data.photos]">'
				+ '<span am-photo-list ng-repeat="pData in data.picture_list"></span>'
				+ '</div>'
				//+ '<div>{{service.getNameById(data.strary_sms_members_userkey[0])}}</div>'
				+ '<div class="fwb">{{service.getNameFromAry(data.strary_sms_members_name)}}</div>'
				+ '</td>'
				+ '<td><i></i><em>{{data.strary_sms_members_userkey.length}}</em></td>'
				+ '<td class="hover1" ng-click="sendingSMS(data)" ng-init="changeBr(data)">{{data.str_sms_content.val}}</td>'
				+ '<td>{{service.setSMSTime(data.str_conv_datetime.val)}}</td>'
				+ '<td class="hover1"><button ng-click="sendAgainSms(data)">{{factory.global.lang_send_again}}</button></td>'
				//+ '<td class="hover1"><button class="nth_x" ng-click="deleteSms(data)"><i class="times"></i></button></td><td></td>'
				+ '<td class="hover1"><button class="nth_x" ng-click="deleteSmsPopup(data)"><i class="times"></i></button></td><td></td>'
			, restrict: 'A'
			, transclude : true
			, link: function(scope, element, attr){}
		}		
	});
	
	// sms 리스트에서 팝업 선택 시
	amoebaModule.directive('amSmsListPopup', function(){
		return {
			template :
				'<td>{{data.name}}</td>'
				+'<td>{{data.number}}</td>'
				+'<td>{{service.getSmsType(data.type)}}</td>'
				+'<td>{{service.getSmsStatus(data.result)}}</td>'
			, restrict: 'A'
			, transclude : true
			, link: function(scope, element, attr){}
		}		
	});
	
	
	// SMS 재발송 리스트
	amoebaModule.directive('amAgainSmsList', function(){ // 0226 hyosng
		return {
			template :
				'<td class="empty"></td>'
//				+ '<td class="nth-child1" ng-if="data.name != \'phoneUser\'"><p>{{data.name}}</p></td>'
//				+ '<td class="nth-child1" ng-if="data.name == \'phoneUser\'"><p>No information</p></td>'
				+ '<td class="nth-child1"><p>{{data.name}}</p></td>'
				+ '<td class="empty1"></td>'
				+ '<td class="nth-child2">'
				
				+ '<div class="MD1-num1Box" ng-class="{\'on\':data.selNum == true}" ng-click="openSmsNumList(data)">'
				+ '<div class="MD1-numBox_inw">'

					// changwon edit 0315 p태그에 data-text부분 추가
				+ '<p data-text="{{factory.global.lang_no_info}}">{{data.number}}</p><i class="MD1-num1_i" ng-class="{\'icon-caret-down\':data.selNum == true, \'icon-caret-up\':data.selNum == false}"></i>'
				+ '</div></div>'
				
				+ '<div class="MD1-num2Box">'
					// changwon edit 0315 p태그에 data-text부분 추가
				+ '<p data-text="{{factory.global.lang_no_info}}" class="MD1-dropList setSmsNum" ng-repeat="numData in data.numberList track by $index" ng-click="setNumber(data, numData)">{{numData}}</p>'
				+ '</div>'
				
				+ '</td>'
				+ '<td class="empty1"></td>'
				+ '<td class="nth-child3">'
				
				+ '<div class="MD1-num1Box" ng-class="{\'on\':data.selType == true}" ng-click="openSmsTypeList(data)">'
				+ '<div class="MD1-numBox_inw">'
				+ '<p data-text="{{factory.global.lang_no_info}}">{{service.getSmsType(data.type)}}</p><i class="MD1-num1_i" ng-class="{\'icon-caret-down\':data.selType == true, \'icon-caret-up\':data.selType == false}"></i>'
				//+ '<p data-text="{{factory.global.lang_no_info}}">{{data.typeName}}</p><i class="MD1-num1_i" ng-class="{\'icon-caret-down\':data.selType == true, \'icon-caret-up\':data.selType == false}"></i>'
				//+ '<p data-text="{{factory.global.lang_no_info}}">{{factory.testSMS()}}</p><i class="MD1-num1_i" ng-class="{\'icon-caret-down\':data.selType == true, \'icon-caret-up\':data.selType == false}"></i>'
				+ '</div></div>'
				+ '<div class="MD1-num2Box">'
					// changwon edit 0315 p태그에 data-text부분 추가
				+ '<p data-text="{{factory.global.lang_no_info}}" class="MD1-dropList setSmsType" ng-click="setType(data, \'Station\')">{{factory.global.lang_forward_droplist_station}}</p>'
					// changwon edit 0315 p태그에 data-text부분 추가
				+ '<p data-text="{{factory.global.lang_no_info}}" class="MD1-dropList setSmsType" ng-click="setType(data, \'Outside\')">{{factory.global.lang_forward_droplist_outside}}</p>'
				+ '</div>'
				+ '</td>'
				
				+ '<td class="empty1"></td>'
				+ '<td class="nth-child4">'
				+ '<p>{{factory.global.lang_smsreuslt_success}}</p>'
				+ '<p>{{factory.global.lang_smsreuslt_failure}}</p>'
				+ '<p>{{factory.global.lang_smsreuslt_ready}}</p>'
				+ '</td>'
				+ '<td class="nth-child5"><button class="nth_x" ng-click="deleteSms(data)"><i class="times"></i></button></td>'
			, restrict: 'A'	
			, link: function(scope, element, attrs){}
	
		}
	});
	
	// 보이스 메일 리스트
	// 0215 hyosung
	/*
	 '<td ng-if="data.bool_conv_log_download.val == 0"><button ng-click="service.downVoice(data)">Download<i></i></button></td>'
	 + '<td ng-if="data.bool_conv_log_download.val == 1"><button ng-click="service.downVoice(data)">Downloaded<i></i></button></td>'
	 */
	 // 0223 changwon
	/*
    '<td ng-if="data.bool_conv_log_download.val === false"><button ng-click="service.downVoice(data)">Download<i></i></button></td>'
                + '<td ng-if="data.bool_conv_log_download.val === true"><button ng-click="service.downVoice(data)">Downloaded<i></i></button></td>'
    */

	/*
	amoebaModule.directive('amVoiceList', ['dateFilter', function(dateFilter) { // 0202 hyosung + '<p>{{service.getNameById(data.str_user_key.val)}}</p>', {{setDateFormat(data)}}
			return {
				template :
				'<td class="hover1" ng-if="data.bool_conv_log_download.val == false"><em class="badge pp" ng-show="data.bool_conv_log_new.val == true">N</em><button class="hover1_1" ng-click="downVoice(data)">Download<i></i></button></td>'
				+ '<td class="hover1" ng-if="data.bool_conv_log_download.val == true"><em class="badge pp" ng-show="data.bool_conv_log_new.val == true">N</em><button class="hover1_1" ng-click="downVoice(data)">Downloaded<i></i></button></td>'
				+ '<td ng-init="service.setVoiceDefault(data)">{{setDateFormat(data)}}</td>'
				+ '<td class="hover1" ng-click="opneVoice(data)" class="overCursor">'
				+ '<p class="hover1_1">{{data.str_conv_name.val}}</p>'
				+ '<div class="horizonGauge_wrap">'
				+ '<div class="horizonGauge_void"><div class="horizonGauge_solid" ng-style="data.width"></div></div>'
				+ '<p><span class="play_time1">{{data.play_time}}</span><span class="play_time2">{{data.str_conv_log_duration.val}}</span></p>'
				+ '</div>'
				+ '</td>'
				+ '<td class="hover1" ng-if="data.isVoicemail_play == false"><span>{{data.str_conv_log_duration.val}}</span><button class="roundBg" ng-click="playVoice(data)"><em ng-class="{\'on\':data.isVoicemail_play==false}"></em></button></td>'
				+ '<td class="hover1" ng-if="data.isVoicemail_play == true"><span>{{data.str_conv_log_duration.val}}</span><button class="roundBg" ng-click="stopVoice(data)"><em ng-class="{\'on\':data.isVoicemail_play==false}"></em></button></td>'
				+ '<td class="hover1"><button class="nth_x" ng-click="deleteVoice(data)"><i class="times hover1_1"></i></button></td>'
				, restrict: 'A'
				, transclude : true
				, link: function(scope, element, attr){

					// 날짜 포맷 변환
					scope.setDateFormat = function(data){
						return dateFilter(new Date(data.str_conv_log_datetime.val), "MM.dd hh:mm a");
					}

				}
			}
		}]
	);
	*/

	amoebaModule.directive('amFlexList', function() { // 0202 hyosung + '<p>{{service.getNameById(data.str_user_key.val)}}</p>', {{setDateFormat(data)}}
			return {
				template :

				'<td ng-click="sendFlexIndex(data)">{{data.str_digit_number.val}} // {{data.int_num.val}}</td><br/>' +
			    //'<td> Description : {{data.description}}</td>' +
				'<td class="fwb" ng-click="openFlexSetting(data)"><i class="icon-cog"></i></td>'
  
				, restrict: 'A'
				, transclude : true
				, link: function(scope, element, attr){
					scope.openFlexSetting = function(data){
						/*scope.factory.mainCtrlScope.isPop = 'flexButton';
						scope.factory.mainCtrlScope.isSetting = false;
						scope.factory.mainCtrlScope.isPopMes = "Flex Button Flag"*/
						scope.factory.GetFlexButtonView(data);

					};
					scope.sendFlexIndex = function(data){
						scope.sendFlexButton(data.int_num.val);
					};

					//scope.sendFlexIndex()
				}
			}
		}
	);
	amoebaModule.directive('amVoiceList', ['dateFilter', function(dateFilter) { // 0202 hyosung + '<p>{{service.getNameById(data.str_user_key.val)}}</p>', {{setDateFormat(data)}}
			return {
				template :
//  #START      changwon ISSUE 46 // 0311 hyosung log_download -->log_new //0405 changwon edit
				'<td class="hover1" ng-if="data.bool_conv_log_new.val == true && data.bPriotiry.val == false"><em class="badge pp" ng-hide="">N</em><button class="hover1_1" ng-click="downVoice(data)" ng-show="data.bool_conv_log_download.val == false"><i></i></button></td>'
				+ '<td class="hover1" ng-if="data.bool_conv_log_new.val == true && data.bPriotiry.val == true"><em class="badge pp" ng-hide="">!</em><button class="hover1_1" ng-click="downVoice(data)" ng-show="data.bool_conv_log_download.val == false"><i></i></button></td>'
				+ '<td class="hover1" ng-if="data.bool_conv_log_new.val == false && data.bPriotiry.val == true"><em class="badge pp urgent" ng-hide="">!</em><button class="hover1_1" ng-click="downVoice(data)" ng-show="data.bool_conv_log_download.val == false"><i></i></button></td>'
				//+ '<td class="hover1" ng-if="data.bool_conv_log_new.val == false"><em class="badge pp" ng-show="data.bool_conv_log_new.val == true">{{data.bool_conv_log_new.val}}N</em><button class="hover1_1" ng-click="downVoice(data)" ng-hide="data.bool_conv_log_download.val === true"><i></i></button></td>'
				+ '<td class="hover1" ng-if="data.bool_conv_log_new.val == false && data.bPriotiry.val == false""><em class="badge pp" ng-show="data.bool_conv_log_new.val == true">{{data.bool_conv_log_new.val}}N</em><button ng-show="data.bool_conv_log_download.val == false" class="hover1_1" ng-click="downVoice(data)"><i></i></button></td>'


				+ '<td class="hover1" ng-click="opneVoice(data)">'
					/*				+ '<td class="hover1" ng-click="opneVoice(data)" class="overCursor">'*/
				+ '<p class="hover1_1">{{data.str_conv_name.val}}</p>'
					// + '<div class="horizonGauge_wrap">'
					// + '<div class="horizonGauge_void"><div class="horizonGauge_solid" ng-style="data.width"></div></div>'
					// + '<p><span class="play_time1">{{data.play_time}}</span><span class="play_time2">{{data.str_conv_log_duration.val}}</span></p>'
					// + '</div>'
				+ '<button class="play"><i></i></button>'
				+ '</td>'
					//  #START      changwon ISSUE 0311
					// + '<td ng-if="data.isVoicemail_play == false"><span>{{data.str_conv_log_duration.val}}</span><button class="roundBg" ng-click="playVoice(data)"><em ng-class="{\'on\':data.isVoicemail_play==false}"></em></button></td>'
				+ '<td><span>{{data.str_conv_log_duration.val.split(".")[0]}}</span></td>'
					//  #END      changwon ISSUE 0311
					/*				+ '<td class="hover1" ng-if="data.isVoicemail_play == true"><span>{{data.str_conv_log_duration.val}}</span><button class="roundBg" ><em ng-class="{\'on\':data.isVoicemail_play==false}"></em></button></td>'*/
					/*
					 + '<td ng-if="data.isVoicemail_play == false"><span>{{data.str_conv_log_duration.val}}</span><button ng-click="service.playVoice(data)"><em ng-class="{\'on\':data.isVoicemail_play==false}"></em></button></td>'
					 + '<td ng-if="data.isVoicemail_play == true"><span>{{data.str_conv_log_duration.val}}</span><button ng-click="service.stopVoice(data)"><em ng-class="{\'on\':data.isVoicemail_play==false}"></em></button></td>'
					 */
					// 날짜 포맷 추가 issue145
					/*				+ '<td ng-init="service.setVoiceDefault(data)"><span>{{setDateFormat1(data)}}</span><span>{{setDateFormat2(data)}}</span></td>'*/
				+ '<td><span>{{setDateFormat1(data)}}</span><span>{{service.setCurrentTime(data.str_conv_log_datetime.val)}}</span></td>'
				//+ '<td class="hover1"><button class="nth_x" ng-click="deleteVoice(data)"><i class="times hover1_1"></i></button></td>'
				+ '<td class="hover1"><button class="nth_x" ng-click="voiceDelete(data)"><i class="times hover1_1"></i></button></td>'
//  #END      changwon ISSUE 46
				, restrict: 'A'
				, transclude : true
				, link: function(scope, element, attr){

					// 날짜 포맷 변환 // 날짜 포맷 추가 issue145
					scope.setDateFormat1 = function(data){
						data.voicemailDate = dateFilter(new Date(data.str_conv_log_datetime.val), "MM.dd");
						return data.voicemailDate;
					}
					// 날짜 포맷 변환2 // 날짜 포맷 추가 issue145
					scope.setDateFormat2 = function(data){
						data.voicemailTime = dateFilter(new Date(data.str_conv_log_datetime.val), "hh:mma");
						//data.voicemailTime = {{service.setMemoTime(data.str_conv_log_datetime.val)}}
						return data.voicemailTime;
					}

				}
			}
		}]
	);


	
	// 파일 리스트
	amoebaModule.directive('amFileList', function(){
		return {
			template :
				'<td>'
				+ '<div ng-class="{1 : \'photo ea1\', 2 : \'photo ea2\', 3 : \'photo ea3\', 4 : \'photo ea4\'}[data.conversation.photos]">'
				+ '<span am-photo-list ng-repeat="pData in data.conversation.picture_list"></span>'
				+ '</div>'
				+ '<div>{{data.conversation.str_conv_name.val}}</div>'
				+ '</td>'
				+ '<td></td>'
				+ '<td><i></i>{{data.str_file_name.val}}</td>'
				+ '<td>{{service.setConversationTime(data.str_conv_log_datetime.val)}}</td>'
				+ '<td><label class="fileupload"><input type="file">Open<i class="icon-aaaaaa"></i></label></td>'
				+ '<td><button class="nth_x"><i class="times"></i></button></td>'
				, restrict: 'A'
					, transclude : true
					, link: function(scope, element, attr){
					}
		}		
	});

	// 파일 리스트
	amoebaModule.directive('amFileList2', function(){
		return {
			template :
			'<td><span ng-class="{voice:data.int_file_type == 1, record:data.int_file_type == 2}"></span></td>'
			+ '<td>{{data.str_file_name}}</td>'
			+ '<td>{{data.str_file_size}}</td>'
			//+ '<td>{{data.str_file_date}}</td>'
			+ '<td>{{setFileDate(data.str_file_date)}}</td>'
			+ '<td class="hover1" ng-click="openFile(data)"><label class="">{{factory.global.lang_open}}</label></td>'
			, restrict: 'A'
			//, transclude : true
			, link: function(scope, element, attr){

			}
		}
	});

	amoebaModule.directive("amCalendar", function() {
	    return {
	        restrict: "E",
	        template : 
						        '<fieldset class="cal_form">'+
									'<legend>달력</legend>'+
									'<div>'+
										'<div class="left">'+
											// '<em class="con1">29</em>'+
											// '<em class="con2">{{month.format("MMMM, YYYY")}}</em>'+
											'<button class=" colorbtnhover">{{factory.global.lang_today}}</button>'+
										'</div>'+
										'<div class="right">'+
											'<em class="con3">{{month.format("MMMM YYYY")}}</em>'+
										'</div>'+
									'</div>'+
									'<table>'+
										'<thead>'+
											'<tr>'+
												'<th>SUN</th>'+
												'<th>MON</th>'+
												'<th>TUE</th>'+
												'<th>WED</th>'+
												'<th>THU</th>'+
												'<th>FRI</th>'+
												'<th>SAT</th>'+
											'</tr>'+
										'</thead>'+
										'<tbody id="days">'+
											'<tr ng-repeat="week in weeks">'+
												'<td id="{{day.isMonth}}" ng-class="{ today: day.isToday, \'notThisMonth_1\': !day.isCurrentMonth, on: day.date.isSame(selected) }" ng-click="select(day)" ng-repeat="day in week.days">{{day.number}}<i></i></td>'+
											'</tr>'+
										'</tbody>'+
									'</table>'+
									'<button class="leftBtn" ng-click="previous()"><i class="icon-angle-left"></i></button>'+
									'<button class="rightBtn" ng-click="next()"><i class="icon-angle-right"></i></button>'+
								'</fieldset>'+
								'<h5>Schedules list</h5>'+
								'<fieldset class="scheduleList">'+
									'<legend>Schedules list</legend>'+
									'<em class="appo_date">24 / 06 / 2015 Mon</em>'+
									'<table>'+
										'<tbody>'+
											'<tr>'+
												'<td><span>AM 10:00</span></td>'+
												'<td>ERICSSON-LG Meeting , LG</td>'+
											'</tr>'+
											'<tr>'+
												'<td><span>AM 10:00</span></td>'+
												'<td>Review Meeting , 8F</td>'+
											'</tr>'+
											'<tr>'+
												'<td><span>AM 10:00</span></td>'+
												'<td>ERICSSON-LG GUI Meeting , Amoeba 6F</td>'+
											'</tr>'+
											'<tr class="noList">'+
												'<td colspan="2">{{factory.global.lang_no_list}}</td>'+
											'</tr>'+
										'</tbody>'+
									'</table>'+
								'</fieldset>',








				// '<div class="header">'
				//     +'<i class="fa fa-angle-left" ng-click="previous()"></i>'
				//     +'<span>{{month.format("MMMM, YYYY")}}</span>'
				//     +'<i class="fa fa-angle-right" ng-click="next()"></i>'
				// +'</div>'
				// +'<div class="week names">'
				//     +'<span class="day">Sun</span>'
				//     +'<span class="day">Mon</span>'
				//     +'<span class="day">Tue</span>'
				//     +'<span class="day">Wed</span>'
				//     +'<span class="day">Thu</span>'
				//     +'<span class="day">Fri</span>'
				//     +'<span class="day">Sat</span>'
			 //    +'</div>'
			 //    +'<div class="week" ng-repeat="week in weeks">'
			 //    	+'<span class="day" ng-class="{ today: day.isToday, \'different-month\': !day.isCurrentMonth, selected: day.date.isSame(selected) }" ng-click="select(day)" ng-repeat="day in week.days">{{day.number}}</span>'
			 //    +'</div>',
	        scope: {
	            selected: "="
	        },
	        link: function(scope, element) {
	            scope.selected = scope.selected.hour(0).minute(0).second(0).millisecond(0);
	            scope.month = scope.selected.clone();
	            scope.today = scope.month.clone();
//	            scope.selected = _removeTime(scope.selected);

	            var start = scope.selected.clone();
	            start.date(1);
	            _removeTime(start.day(0));

	            _buildMonth(scope, start, scope.month);
	            
	            scope.selectToday = function(){
	            	
	            	scope.selected = scope.today.clone();	            	
	            	scope.month = scope.selected.clone();
		            var start = scope.selected.clone();
		            start.date(1);
		            _removeTime(start.day(0));

		            _buildMonth(scope, start, scope.month);
		            
	            }
	            
	            scope.select = function(day) {
	                scope.selected = day.date;
	            };

	            scope.next = function() {
	                var next = scope.month.clone();
	                _removeTime(next.month(next.month()+1).date(1));
	                scope.month.month(scope.month.month()+1);
	                _buildMonth(scope, next, scope.month);
	            };

	            scope.previous = function() {
	                var previous = scope.month.clone();
	                _removeTime(previous.month(previous.month()-1).date(1));
	                scope.month.month(scope.month.month()-1);
	                _buildMonth(scope, previous, scope.month);
	            };
	        }
	    };
	    
	    function _removeTime(date) {
	        return date.day(0).hour(0).minute(0).second(0).millisecond(0);
	    }

	    function _buildMonth(scope, start, month) {
	        scope.weeks = [];
	        var done = false, date = start.clone(), monthIndex = date.month(), count = 0;
	        while (!done) {
	            scope.weeks.push({ days: buildWeek(date.clone(), month) });
	            date.add(1, "w");
	            done = count++ > 2 && monthIndex !== date.month();
	            monthIndex = date.month();
	        }
	    }

	    function buildWeek(date, month) {
	        var days = [];
	        for (var i = 0; i < 7; i++) {
	            days.push({
	                name: date.format("dd").substring(0, 1),
	                number: date.date(),
	                isCurrentMonth: date.month() === month.month(),
	                isMonth : ((date.month() + 1)+"_"+date.date()),
	                isToday: date.isSame(new Date(), "day"),
	                date: date
	            });
	            date = date.clone();
	            date.add(1, "d");
	        }
	        return days;
	    }
	});
//	amoebaModule.directive('amDraggable', ['$document', function($document) {
//		return {
//			scope: {
//				factory: '='
//			},
////		      restrict: 'A',
//		      link: function(scope, elm, attrs) {
//		        var startX, startY, initialMouseX, initialMouseY;
//		        elm.css({position: 'absolute'});
//		 
//		        elm.bind('mousedown', function($event) {
//		          startX = elm.prop('offsetLeft');
//		          startY = elm.prop('offsetTop');
//		          initialMouseX = $event.clientX;
//		          initialMouseY = $event.clientY;
//		          elm.css({
//			            width:  '100px',
//			            height: '100px'
//			          });
//		          $document.bind('mousemove', mousemove);
//		          $document.bind('mouseup', mouseup);
//		          return false;
//		        });
//		 
//		        function mousemove($event) {
//		          var dx = $event.clientX - initialMouseX;
//		          var dy = $event.clientY - initialMouseY;
//		          elm.css({
//		            top:  startY + dy + 'px',
//		            left: startX + dx + 'px'
//		          });
//		          return false;
//		        }
//		 
//		        function mouseup() {
//		          $document.unbind('mousemove', mousemove);
//		          $document.unbind('mouseup', mouseup);
//		        }
//		      }
///////////////////////////////////////////////////////////////////////////////////////			
//		    link: function(scope, element, attr) {
//		    		var factory = scope.factory;
//		    		factory.currentDragData = undefined;
//					var startX = 0, startY = 0, x = 0, y = 0, gabX = 0, gabY = 0;
//					var obj = angular.element();
//						
//					element.on('mousedown', function(event) {
//						var offset = $(this).offset();
//						factory.isDragEnd = false;
//						
//						event.preventDefault();
//						gabX = event.pageY - offset.top;
//						gabY = event.pageX - offset.left; 
//						    
//						$document.on('mousemove', mousemove);
//						$document.on('mouseup', mouseup);
//		      });
//		      
//		      function mousemove(event) {
//			        y = event.pageY - startY - gabX;
//			        x = event.pageX - startX - gabY;
//			        
//			        $('#dragDummy').css({
//			        	
//						top: y + 'px',
//						left: x + 'px'
//			        });
//			        //console.log(x+"  //  "+y);
//				}
//				
//				function mouseup() {
//					$('#dragDummy').css({
//						
//						heigth : "0",
//						width : "0",
//						borderWidth: "0px"
//					    /*background: "#000",
//				    	opacity: "0.01"
//				    	*/
//						
///*						"background" : "#FFC19E"*/
//					});
////					factory.addedDragData = {};
//					angular.copy(factory.currentDragData, factory.addedDragData);
//					$document.off('mousemove', mousemove);
//					$document.off('mouseup', mouseup);
//				}
//		    }
///////////////////////////////////////////////////////////////////////////////////////////////////////////////			
//		}
//	}
//	]);
//	amoebaModule.directive('amDraggablett', ['$document', function($document) {
//		  return {
//		    link: function(scope, element, attr) {
//		      var startX = 0, startY = 0, x = 0, y = 0;
//		      var obj = angular.element();
//		      var wi = 100;
//		      var he = 100;
//		      var defVal = $(".tab-cont").width();
//		      var winWid = angular.element($document).width() - defVal;
//		      //console.log(angular.element($document).width());
////		      var winHei = angular.element($document).height;
////		      element.css({
////		       position: 'relative',
////		       border: '1px solid red',
////		       backgroundColor: 'lightgrey',
////		       cursor: 'pointer'
////		    	   
////		      });
////		      element.on('mouseover', function(event){
////		    	  
////		    	  
////		    	  
////		    	  	event.preventDefault();
////			        startX = winWid;
////			        startY = event.pageY - y;
////			        $('#dragBackground').css({
////			        	width: 0,
////			        	height: 0,
////			        	top: startY,
////			        	left: startX
////			       });
////		      });
//		      element.on('mousedown', function(event) {
////		    	  startX = 0;
////		    	  startY = 0;
////		    	  x = 0; 
////		    	  y = 0;
////		    	 $('#home').before("<div class='trplayer' id='testtest'></div>");		    	 
////		    	 angular.element(document.getElementById('#home')).append($compile("<div style=></div>")(scope));
//		    	 
//		        // Prevent default dragging of selected content
//		        event.preventDefault();
//		        startX = event.pageX - x;
//		        startY = event.pageY - y;
//		        $('#dragDummy').css({
//		        	width: wi+"px",
//		        	height: he+"px",
//		        	top: startY,
//		        	left: startX + winWid+x
//		        });
//		        
//		        
//		        
//		        $document.on('mousemove', mousemove);
//		        $document.on('mouseup', mouseup);
//		      });
//
//		      function mousemove(event) {
//		        y = event.pageY - startY ;
//		        x = event.pageX - startX;
//		        
//		        $('#dragDummy').css({
//		        	
//					width: wi+"px",
//					height: he+"px",
//					top: y + 'px',
//					left:  (winWid+x) + 'px'
//		        });
//		        //console.log(winWid+" // "+x+"  //  "+y);
//		      }
//
//		      function mouseup() {
//				$('#dragDummy').css({
//					width: 0,
//					height: 0,
//					top: 0,
//					left: 0
//				});
//		        $document.off('mousemove', mousemove);
//		        $document.off('mouseup', mouseup);
//		      }
//		    }
//		  };
//		}
//	]);
	
	amoebaModule.directive('myCurrentTime', ['$interval', 'dateFilter',
     function($interval, dateFilter) {
       // return the directive link function. (compile function not needed)
       return function(scope, element, attrs) {
//    	   var format1 = 'HH:mm';  // date format

    	   var format1 = 'hh:mm';  // date format
    	   var format2 = 'MMM dd EEEE';
           var stopTime; // so that we can cancel the time updates

         // used to update the UI
         function updateTime() {
        	var d = new Date()
			scope.toptime = dateFilter(d, format1);

			 var hours = d.getHours();
			 var lan = scope.factory.loginInfo.str_language.val;
			 if(hours >=12){
				 if(lan == "KOR"){
					 scope.toptime = scope.factory.global.lan_PM + " " + scope.toptime;
				 }
				 else if(lan == "ENG"){
					 scope.toptime = scope.toptime + " " + scope.factory.global.lan_PM;
				 }
			 }
			 else{
				 if(lan == "KOR"){
					 scope.toptime =scope.factory.global.lan_AM + " " + scope.toptime;
				 }
				 else if(lan == "ENG"){
					 scope.toptime = scope.toptime + " " + scope.factory.global.lan_AM;
				 }
			 }


			 scope.topDate = dateFilter(d, format2);
			 var arr = scope.topDate.split(" ");
			 var month = getMonth(arr[0]);
			 var dayname = getDay(arr[2]);
			 ////console.log(dayname);
			 ////console.log("schedulebar");
			 scope.topDate = month +" " + arr[1] + " " + dayname;

//           element.text(dateFilter(new Date(), scope.format));
         }
		   function getDay(day){

			   if(day.startsWith('Mon')){
				   day = scope.factory.global.Main_Day_Mon;
			   }
			   else if(day.startsWith('Tue')){
				   day = scope.factory.global.Main_Day_Tue;
			   }
			   else if(day.startsWith('Wed')){
				   day = scope.factory.global.Main_Day_Wed;
			   }
			   else if(day.startsWith('Thu')){
				   day = scope.factory.global.Main_Day_Thu;
			   }
			   else if(day.startsWith('Fri')){
				   day = scope.factory.global.Main_Day_Fri;
			   }
			   else if(day.startsWith('Sat')){
				   day = scope.factory.global.Main_Day_Sat;
			   }
			   else if (day.startsWith('Sun')){
				   day = scope.factory.global.Main_Day_Sun;
			   }
			   return day;


		   }
		   function getMonth(month){
			   if(month.startsWith('Jan')){
				   month = scope.factory.global.Month_Jan;
			   }
			   else if(month.startsWith('Feb')){
				   month = scope.factory.global.Month_Feb;
			   }
			   else if(month.startsWith('Mar')){
				   month = scope.factory.global.Month_Mar;
			   }
			   else if(month.startsWith('Apr')){
				   month = scope.factory.global.Month_Apr;
			   }
			   else if(month.startsWith('May')){
				   month = scope.factory.global.Month_May;
			   }
			   else if(month.startsWith('Jun')){
				   month = scope.factory.global.Month_Jun;
			   }
			   else if (month.startsWith('Jul')){
				   month = scope.factory.global.Month_Jul;
			   }
			   else if (month.startsWith('Aug')){
				   month = scope.factory.global.Month_Aug;
			   }
			   else if (month.startsWith('Sep')){
				   month = scope.factory.global.Month_Sep;
			   }
			   else if (month.startsWith('Oct')){
				   month = scope.factory.global.Month_Oct;
			   }
			   else if (month.startsWith('Nov')){
				   month = scope.factory.global.Month_Nov;
			   }
			   else if (month.startsWith('Dec')){
				   month = scope.factory.global.Month_Dec;
			   }
			   return month;
			   
		   }
//
////         // watch the expression, and update the UI on change.
//         scope.$watch(attrs.myCurrentTime, function(value) {
//           format = value;
//           updateTime();
//         });
//
         stopTime = $interval(updateTime, 1000);
//
//         // listen on DOM destroy (removal) event, and cancel the next UI update
//         // to prevent updating time after the DOM element was removed.
         element.on('$destroy', function() {
           $interval.cancel(stopTime);
         });
       }
     }]);
	
	// 프로필 달력
	amoebaModule.directive('amProfileCalendar', function(){
		return {
			template :
				'<li>'
				+ '<div class="top1"><strong>{{profileDate}}</strong><button ng-click="profileDefault()">TODAY</button></div>'
				+ '<div class="con1"><fieldset class="cal_form"><legend>달력</legend>'
				+ '<table>'
				+ '<thead><tr><th>SUN</th><th>MON</th><th>TUE</th><th>WED</th><th>THU</th><th>FRI</th><th>SAT</th></tr></thead>'
				+ '<tbody>'
				+ '<tr>'
				+ '<td ng-repeat="day in profileWeek.days" class="schDay" ng-class="{\'today\':day.isToday == true, \'on\':day.date.isSame(onSelected)}" ng-click="profileSch(day)">{{day.number}}<i></i></td>'
				+ '</tr>'
				+ '</tbody>'
				+ '</table>'
				+ '<button class="leftBtn" ng-click="profilePrevious()"><i class="icon-angle-left"></i></button>'
				+ '<button class="rightBtn" ng-click="profileNext()"><i class="icon-angle-right"></i></button>'
				+ '</fieldset></div>'
				+ '</li>'
				+ '<li>'
				+ '<div class="top1"><strong>{{profilSchDate}}</strong></div>'
				+ '<div class="con1">'
				+ '<p ng-repeat="data in schList">{{data.content}} {{data.time}}</p>'
//				+ '<p>LG Ericsson meeting 3:00 , LG</p>'
				+ '</div>'
				+ '</li>'
			, restrict: 'A'
			, transclude : true
			, link: function(scope, element){

				// 스케쥴 일정 데이터 
				scope.profileSchedule = scope.schedule;
				
				// 프로필이 유저 변경 시
				scope.$watch('currentUserProfile', function() {
					scope.profileUser = scope.currentUserProfile;
					scope.profileDefault();
					scope.buildSchedule();
				});
				
				// 선택 날짜 변경 시
				scope.$watch('onSelected', function() {
					scope.buildSchedule();
				});
				
				// 시간 관련
				scope.profileSelected = moment().hour(0).minute(0).second(0).millisecond(0);				
				scope.onSelected = scope.profileSelected.clone();
				scope.profileMonth = scope.profileSelected.clone();
		
	            var start = scope.profileSelected.clone();
	            start.date(1);
	            profileRemoveTime(start.day(0));

	            scope.profilePrevious = function() {
	            	var index = scope.profileWeeks.indexOf(scope.profileWeek);
	            	if(0 < index ){
	            		scope.profileWeek = scope.profileWeeks[index - 1];
	            	}
	            	else{
	            		var check = scope.profileWeeks[0].days[0].date.format("D");
		                var profilePrevious = scope.profileMonth.clone();
		                
		                profileRemoveTime(profilePrevious.month(profilePrevious.month()-1).date(1));
		                scope.profileMonth.month(scope.profileMonth.month()-1);
		                profileBuildMonth(scope, profilePrevious, scope.profileMonth);
		                
		                if(check == 1){
		                	scope.profileWeek = getWeek(scope.profileWeeks, scope.profileWeeks[scope.profileWeeks.length - 1].days[6].date); 
		                }
		                else{
		                	scope.profileWeek = getWeek(scope.profileWeeks, scope.profileWeeks[scope.profileWeeks.length - 2].days[6].date); 
		                }
	            	}

	            	scope.profileDate = scope.profileWeek.days[0].date.format("MMM YYYY");
	            };
	            
	            scope.profileNext = function() {
	            	var index = scope.profileWeeks.indexOf(scope.profileWeek) + 1;
	            	if(index < scope.profileWeeks.length ){
	            		scope.profileWeek = scope.profileWeeks[index];
	            	}
	            	else{
	            		var profileNext = scope.profileMonth.clone();
	            		 
	  	                profileRemoveTime(profileNext.month(profileNext.month()+1).date(1));
	  	                scope.profileMonth.month(scope.profileMonth.month()+1);
	  	                profileBuildMonth(scope, profileNext, scope.profileMonth);
	  	                
	  	                var check = scope.profileWeeks[0].days[0].date.format("D");
	  	                
	  	                if(check == 1){
	  	                	scope.profileWeek = getWeek(scope.profileWeeks, scope.profileWeeks[0].days[6].date);
	  	                }
	  	                else{
	  	                	scope.profileWeek = getWeek(scope.profileWeeks, scope.profileWeeks[1].days[6].date);
	  	                }
	            	}
	            	
	            	scope.profileDate = scope.profileWeek.days[6].date.format("MMM YYYY");
	            };
	            
	            scope.profileSch = function(day){
		            scope.profileDate = day.date.format("MMM YYYY");
		            scope.profilSchDate = day.date.format("MMM Do");
		            scope.onSelected = day.date;
	            };

	            scope.profileDefault = function(){
	            	scope.onSelected = scope.profileSelected.clone();
	            	scope.profileMonth = scope.profileSelected.clone();
	            	
		            profileBuildMonth(scope, start, scope.profileMonth);
		            scope.profileWeek = getWeek(scope.profileWeeks, scope.profileSelected);
		            scope.profileDate = scope.profileSelected.format("MMM YYYY");
		            scope.profilSchDate = scope.profileSelected.format("MMM Do");

	            };

	            scope.buildSchedule = function(){

	            	if(!angular.isDefined(scope.profileUser) || scope.profileUser == null){
	            		return;
	            	}
	            	
	            	scope.schList = [];
	            	
	            	for(var i in scope.profileSchedule){
	            		if(scope.profileSchedule[i].str_user_key.val == scope.profileUser.str_user_key.val){
	            			if(scope.profileSchedule[i].time.indexOf(scope.onSelected.format("YYYY/M/D")) > -1){
	            				scope.schList.push(scope.profileSchedule[i]);
	            			}
	            		}
	            	}
	            	
	            	scope.schList.sort(function(a, b){ 
	            		return a.time < b.time ? -1 : a.time > b.time ? 1 : 0;  
	            	});
	            
	            };
	            
	            scope.profileDefault();
   
	        }				
		};
	    
	    function profileRemoveTime(date) {
	        return date.day(0).hour(0).minute(0).second(0).millisecond(0);
	    }

	    function profileBuildMonth(scope, start, month) {
	        scope.profileWeeks = [];
	        var done = false, date = start.clone(), monthIndex = date.month(), count = 0;
	        while (!done) {
	            scope.profileWeeks.push({ days: buildWeek(date.clone(), month) });
	            date.add(1, "w");
	            done = count++ > 2 && monthIndex !== date.month();
	            monthIndex = date.month();
	        }
	    }

	    function buildWeek(date, month) {
	        var days = [];
	        for (var i = 0; i < 7; i++) {
	            days.push({
	                name: date.format("dd").substring(0, 1),
	                number: date.date(),
	                isCurrentMonth: date.month() === month.month(),
	                isToday: date.isSame(new Date(), "day"),
	                click: false,
	                date: date
	            });
	            date = date.clone();
	            date.add(1, "d");
	        }
	        return days;
	    }
	    
	    // 현재 날짜 기준의 week를 가져온다
	    function getWeek(weeks, day){
        	for(var i = 0; i < weeks.length; i++){
        		for(var j = 0; j < weeks[i].days.length; j++){
        			if(String(day._d) == String(weeks[i].days[j].date._d)){
        				return weeks[i];
        			}
        			
        		}
        	}
        }
	    
	});
	
	amoebaModule.directive('file', function(){
	    return {
	        scope: {
	            file: '='
	        },
	        link: function(scope, el, attrs){
	            el.bind('change', function(event){
	                var files = event.target.files;
	                var file = files[0];
	                scope.file = file ? file.name : undefined;
	                scope.$apply();
	            });
	        }
	    };
	});

	amoebaModule.directive('onlyDigits', function(){
		return {
			require: 'ngModel',
			link: function(scope, element, attrs, modelCtrl) {

				modelCtrl.$parsers.push(function (inputValue) {
					var transformedInput = inputValue ? inputValue.replace(/[^(0-9)*#]/gi,'') : '';

					if (transformedInput!=inputValue) {
						modelCtrl.$setViewValue(transformedInput);
						modelCtrl.$render();
					}

					return transformedInput;
				});
			}
		};
	});

}(angular));
